*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky                                             *
*... 09.12.2001                                                              *
*                                                                            *
      SUBROUTINE  TXRCHR(fkey, inam, Cval, IER) 
*     -----------------------------------                                    *
* read ONE character variable with a name 'INAM', return  IVAL               *
*............................................................................*
      implicit none
      
      character *6 fkey
      integer IER
      character *(*) Cval 
      character *40 inam
      character *80 strout 
      integer i, i1, i2
*
      call txrstr(fkey, inam,  strout, ier) 
       if(ier.eq.1) return 
        i1 = 0
        i2 = 0
        do i = 1,80 
         if(strout(i:i).ne.' '.and.i1.eq.0) i1 = i
         if(strout(i:i).eq.' '.and.i1.ne.0) then
          i2 = i - 1
          goto 99
         endif
        enddo
        if(i1.eq.0) return 
 99    cval = '                                      '
       cval = strout(i1:i2)
      return  
      end
*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky                                             *
*... 12.11.2001                                                              *
*                                                                            *
      SUBROUTINE  TXRINT(fkey, inam, Ival, IER) 
*     -----------------------------------                                    *
* read ONE INTEGER variable with a name 'INAM', return  IVAL                 *
*............................................................................*
      implicit none
      
      character *6 fkey
      integer IER
      integer ival
      character *40 inam
      character *80 strout 

      call txrstr(fkey, inam,  strout, ier) 
       if(ier.ne.1) read(strout(1:80),*) ival 
      return
      end
c----------------------------------------------------------------------------c
*... author : Serge Slabospitsky                                             *
*... 12.11.2001                                                              *
*                                                                            *
      SUBROUTINE TXRFL8(fkey, inam, Rval, IER) 
*     ----------------------------------                                     *
* read ONE REAL8 (double precision) variable with a name 'INAM', return RVAL *
*............................................................................*
      implicit none
      
      character *6 fkey
      integer IER
      double precision rval 
      character *40 inam
      character *80 strout 
*
      call txrstr(fkey, inam, strout, ier) 
      if(ier.ne.1) read(strout(1:80),*) rval 
      return
      end
c----------------------------------------------------------------------------c
*... author : Serge Slabospitsky                                             *
*... 12.11.2001                                                              *
*                                                                            *
      SUBROUTINE TXRFL4(fkey, inam, Rval, IER) 
*     ----------------------------------                                     *
* read ONE REAL (single precision) variable with a name 'INAM', return RVAL  *
*............................................................................*
      implicit none
      
      character *6 fkey
      integer IER
      real  rval 
      character *40 inam
      character *80 strout 
*
      call txrstr(fkey, inam, strout, ier) 
      if(ier.ne.1) read(strout(1:80),*) rval 
      return
      end
c----------------------------------------------------------------------------c
*... author : Serge Slabospitsky                                             *
*... 11.11.2001                                                              *
*                                                                            *
      SUBROUTINE TXRSTR(fkey, inam, strout, ier) 
*     ------------------------------------                                   *
* input : INAM is character string (up to 40 symbols) with '=' as the end    *
* outout: STROUT is character string with value (values)                     *
*         IER = 0 (1) variable is readed and returned                        *
*............................................................................*
*  The data file should has the following form.                              *
*                                                                            *
* 1. totally blank card is ignored                                           *
* 2. comment card has a first non-blank character the single symbol '*',     *
*    the further contents of the card are ignored                            *
* 3. The data-card should has the following format:                          *
*   'variable's name' '=' 'variable's value' 'comment (not needed)'          *
* 4. the card without '=' character will be readed but not recognized        *
*............................................................................*
      implicit none
      
      integer IER, IERF
      save IERF
*
      integer lens
      parameter (lens=40)
*
      integer nfil                ! number of external data files
      parameter (nfil=10)
      integer LUNfil(nfil)        ! input channel for reading CMSJET param
      character *80 filnam(nfil)  ! Name of the file
      data lunfil/71, 77, -1, -1, -1
     &          , -1, -1, -1, -1, -1/
      data filnam /'txrun.dat', 'cmsjet.dat', 'cmsrun.dat', 'xx', 'xx'
     &             ,'xx',     'xx',        'xx', 'xx', 'xx'/

      integer lundat
      character *80 TXname       ! name of the input data file 
      
      character *6 fkey
      character *6 fnam(nfil)
      data fnam/'trxdat', 'cmsjet', 'cmsrun', 'xxxxxx', 'xxxxxx'
     &         ,'xxxxxx', 'xxxxxx', 'xxxxxx', 'xxxxxx', 'xxxxxx'/

      character *40 inam, vv, vst(nfil,400), ww 
      character *80 strout 
*                    
      character *80 aa, vnu(nfil,400)
      integer kin(nfil), I, j1, jj, ifil 
      logical first, firsf(nfil)
      data first /.TRUE./
      save first, firsf
*
      
      if(first) then 
        do i = 1, nfil
         firsf(i) = .true.
        enddo
       first = .false.
      endif
*
      IFIL = -1
      lundat = -1
      do i = 1, 6
       if(ichar(fkey(i:i)).ge.65.AND.ichar(fkey(i:i)).LE.90) then
         fkey(j1:j1) = char(ichar(fkey(j1:j1))+32)
       endif
      enddo

       do i = 1, nfil
        if(fkey(1:6).eq.fnam(i)(1:6)) then
         ifil = i
         lundat = lunfil(i)          
         txname = filnam(i)
        endif
       enddo
       if(lundat.eq.-1) goto 200


      if(.NOT.firsf(ifil))  goto 999 
      IERF = 0

      open(lundat, FILE=txname, status='old',form='formatted',ERR=200) 
      kin(ifil) = 0
 101  if(IERF.eq.1) goto 201
      read(lundat,'(a)',end=998,err=998) aa 
        if(aa(1:1).eq.'C') goto 101   ! this is a comment card, ignored 
       do i = 1,80
        if(aa(i:i).ne.' ') then 
         j1 = 1  ! non-blank character
         if(aa(i:i).eq.'*') goto 101  ! first non-blank item = '*' -  comment
         goto 16
        endif        
       enddo
       goto 101 !  blank string 
 16    j1 = 0
       do i = 1,80
       if(aa(i:i).ne.' ') then 
         if(aa(i:i).eq.'='.and.j1.eq.0) j1 = i
        endif
      enddo
      if(j1.eq.0) goto 101 ! all items are blanck symbols or there is no '='
        kin(ifil) = kin(ifil) + 1
       jj = 0
       do i = 1,(j1-1)
       if(aa(i:i).ne.' ') then
       jj = jj + 1    
        if(ichar(aa(i:i)).ge.65.AND.ichar(aa(i:i)).LE.90) then
           vv(jj:jj) = char(ichar(aa(i:i))+32)
         else
           vv(jj:jj) = aa(i:i)
         endif
        endif
        enddo
        vst(ifil,kin(ifil))(1:jj) = vv(1:jj)
        vnu(ifil,kin(ifil)) = aa((j1+1):80)
       goto 101
 998   continue
        firsf(ifil) = .FALSE.
        close(lundat)
 999  IER = 1
      j1 = 0
      do i=1,lens
        if(inam(i:i).eq.'='.and.j1.eq.0) j1 = i
      enddo
      if(j1.eq.0) return
* remove blank characters and transform capital letters to small ones
       jj = 0
       do i = 1,(j1-1)
       if(inam(i:i).ne.' ') then
       jj = jj + 1    
        if(ichar(inam(i:i)).ge.65.AND.ichar(inam(i:i)).LE.90) then
           vv(jj:jj) = char(ichar(inam(i:i))+32)
         else
           vv(jj:jj) = inam(i:i)
         endif
        endif
        enddo
        ww(1:jj) = vv(1:jj)
       j1 = jj

       DO i = 1,kin(ifil)
         vv = vst(ifil,i)
         IF(ww(1:j1).eq.vv(1:j1)) THEN 
             IER = 0
             strout(1:80) = vnu(ifil,i)(1:80)
             return
         ENDIF 
       enddo
      IER = 1
      return
 200  continue
      j1 = 0
      do i=1,lens
        if(inam(i:i).eq.'='.and.j1.eq.0) j1 = i
      enddo
       if(j1.eq.0) then 
         print*,'Item ',inam,' can not to be read from ',txname
       else 
         print*,'Item ',inam(1:j1),' can not to be read from ',txname
       endif
 201  IERF = 1
      IER = 1
      return
      END
*----------------------------------------------------------------------------c


