c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  09.09.2002                                  *
*   t W production                                                           *
*   TopReX code = 3                                                          *
*   color flow and showering description for PYTHIA                          *
*............................................................................*
      subroutine COLORF_03(ip1, ip2)
*     ------------------------------                                         *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer ip1, ip2, I, iglu, iqrk, kfw, IR, kff1, kff2
      Integer ntop, kpp(2), kftop(2)
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRES = 1 : top quark,  IRES = 2 : W-boson, 
*     IRES = 3 : H+- boson,  IRES = 4 : Z-boson 
      integer Ires
*.................  tW process   ............................................*
*                                      / [5] nu(U~)                          *
*                                     /                                      *
*     g(b)[1] ---------O/\/\ W*[4]/\/0                                       *
*                      |              \                                      *
*                      |               \ [6] L(D)                            *
*                      |                                                     *
*     b(g)[2] ---------O============ T [3]                                   *
*............................................................................*
*
*                 1     2        3   4   5   6 
*      nup = 6  ! g(b)  g(b~) -> T   W*  N1  L1 
* how PYTHIA will be treated
        istup(3) = 2   ! final top 
        istup(4) = 2   ! virtual W* 
        istup(5) = 1   ! final NU(U~) from W[3] 
        istup(6) = 1   ! final L(D)   from W[3] 

        pup(5,4) = dsqrt(pup(4,4)**2-pup(1,4)**2
     &                 - pup(2,4)**2-pup(3,4)**2)
* parent's lines of final nu(U) L(D) 
        mothup(1,3)=1  ! final top 
        mothup(2,3)=2  !
         mothup(1,4)=1  ! final W 
         mothup(2,4)=2  !
* KF code and color flow
         if(idup(1).eq.0) then
          iglu = 1
          iqrk = 2
         else
          iglu = 2
          iqrk = 1
         endif
         idup(iglu) = 21  
        if(idup(iqrk).gt.0) then
          idup(4) = -24   ! W-
          idup(3) = +6    ! Top 
        else   
          idup(4) = +24   ! W+
          idup(3) = -6    ! Tbar 
        endif 
        ipar(50) = 300
        icolup(1,iglu) = ipar(50) + 1
        icolup(2,iglu) = ipar(50) + 2
      if(idup(3).eq.6) then 
        icolup(1,3)    = icolup(1,iglu)
        icolup(1,iqrk) = icolup(2,iglu)
      else
        icolup(2,3)    = icolup(2,iglu)
        icolup(2,iqrk) = icolup(1,iglu)
      endif
* showering

* fill HEPEUP for W-boson and its decays products 
      
      kfw = idup(4)          ! KF code of second W
      ires = 2
      call Res_branch(ires, kfw, Ir)
* fill masses and HEPEUP information for the fermions from second W-boson
      kfw = kfw / abs(kfw)         ! +1(-1) for W+(W-)
      kff1 = kfw * FID(Ires,Ir,1)   ! KF code of first  fermion 
      kff2 = kfw * FID(Ires,Ir,2)   ! KF code of second fermion 
      call colorf_bff(4, 5, kff1,  6, kff2) 
* parameters for top decay
*      return
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
         ntop = ntop + 1
         kpp(ntop) = I
         kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) call top_decay(ntop, kpp, kftop) 
      return
      end
