
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky,     09.09.2002                              *
*   W* and H* production                                                     *
*   TopReX code = 4      ==> top b   final state                             *
*   TopReX code = 7      ==> nu  tau final state                             *
*   color flow and showering description for PYTHIA                          *
*............................................................................*
      subroutine COLORF_04(i1, i2)
*     ----------------------------                                           *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      integer I, i1, i2, izn, kf1, kf2, kpp(2), ntop, kftop(2) 
*............. W* + H* process   ............................................*
*                            Ipar(1) =  4        8                           *
*     q(q~)[1]\                       / T [4]    NU[4]                       *
*              \                     /                                       *
*               \                   /                                        *
*                O/\ W* + H*[3] \/\O                                         *
*               /                   \                                        *
*              /                     \                                       *
*     q~(q)[2]/                       \ B [5]    TAU[5]                      *
*............................................................................*
*
*                  1      2       3          4       5  
*      nup=5    ! q(q~)  q~(q) -> (W* H*) -> T (NU)  Bbar (TAU) 
* how PYTHIA will be treated
        istup(3) = 2   ! virtual boson 
        istup(4) = 1   ! final NU(top) 
        istup(5) = 1   ! final B
* parent's lines of final nu(U) L(D) 
        mothup(1,3)=1  
        mothup(2,3)=2  
         mothup(1,4)=3 
         mothup(2,4)=3 
          mothup(1,5)=3 
          mothup(2,5)=3 
* KF code and color flow
       if    (abs(ipar(21)).eq.1) then
          idup(3) = -24
       elseif(abs(ipar(21)).eq.2) then
          idup(3) = -37
       else
          idup(3) = 94
       endif

      if(i1.eq.2.OR.i1.eq.4.OR.i2.eq.2.OR.i2.eq.4) then
       idup(3)=-idup(3)   ! T Bbar  or NU TAU+ 
       izn =  1    
      else
       izn = -1
      endif      

       if(Ipar(1).eq.4.or.Ipar(1).eq.8) then
        kf1 = izn * 6
        kf2 = -izn * 5
        istup(4) = 2  ! final top
      else
        kf1 =  izn*16
        kf2 = -izn*15
      endif 
* color flow for initial quarks
      ipar(50) = 300
        if(i1.gt.0) then
         icolup(1,1) = ipar(50) + 1 
         icolup(2,2) = ipar(50) + 1 
        else
         icolup(2,1) = ipar(50) + 1 
         icolup(1,2) = ipar(50) + 1 
        endif
* colorf flow for final fermions
      idup(4) = kf1 
      idup(5) = kf2 
      ipar(50) = 300 + 100
        if(idup(4).eq.6) then
         icolup(1,4) = ipar(50) + 1 
         icolup(2,5) = ipar(50) + 1 
       elseif(idup(4).eq.-6) then
         icolup(2,4) = ipar(50) + 1 
         icolup(1,5) = ipar(50) + 1 
       endif

      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
         ntop = ntop + 1
         kpp(ntop) = I
         kftop(ntop) = idup(I)
       endif 
      enddo
      if(ntop.ge.1)  call top_decay(ntop, kpp, kftop) 
      RETURN
      end
