c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  06.06.2006                                  *
* FCNC : G q -> q T                                                          *
*   TopReX code = 33                                                         *
      subroutine COLORF_33(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer I, ip1, ip2, ntop, kpp(2), kftop(2), 
     & icl1, icl2, icl3 
      integer idia, ig1, ig2, iq
      integer           idig(4)
      double precision        hrd(5,4)
      common /tplFC_GQ/ idig, hrd
      double precision hv 
      common /topol1/ hv(4)    ! TOP lepton polarisation vector
*....... FCNC g q -> g t ....................................................*
*     q   [1] ---------O----------  q[3]                                     *
*                      <                                                     *
*                      <                                                     * 
*     q   [2] ---------O==========  T [4]                                    *
*............................................................................*
* HEPEUP :        1     2       3     4 
*       nup = 4 
* how PYTHIA will be treated
        istup(4) =  2 ! final top 
        istup(3) =  1 ! final q
*
      idup(1) = ip1 
       if(idup(1).eq.0) idup(1) = 21
      idup(2) = ip2
       if(idup(2).eq.0) idup(2) = 21
* parent's lines
          mothup(1,3)=1  ! final gluon
          mothup(2,3)=2  !
           mothup(1,4)=1  ! final top
           mothup(2,4)=2  !
*
       idup(3) = 21 ! always
       ig2 = 3
      If(ip1.eq.0) then
        ig1 = 1
        iq  = 2 
                    idup(4) = +6
       if(ip2.lt.0) idup(4) = -6
        if(abs(ip2).eq.2) then
         idia = idig(1) 
           do i = 1,4
            hv(i) = hrd(1,i)
           enddo
        endif
        if(abs(ip2).eq.4) then
         idia = idig(3) 
           do i = 1,4
            hv(i) = hrd(3,i)
          enddo
        endif
      ElseIf(ip2.eq.0) then
        ig1 = 2
        iq  = 1 
                    idup(4) = +6
       if(ip1.lt.0) idup(4) = -6
        if(abs(ip1).eq.2) then
         idia = idig(2) 
           do i = 1,4
            hv(i) = hrd(2,i)
           enddo
        endif
        if(abs(ip1).eq.4) then
         idia = idig(4) 
           do i = 1,4
            hv(i) = hrd(4,i) 
           enddo
        endif
      EndIf
*  color flow 
       ipar(50) = 301
       icl1 = 301
       icl2 = 302
       icl3 = 303
* 
      IF(idup(4).eq.+6) then ! Top
       if(idia.eq.1) then ! t-channel
          icolup(1,ig1) = icl1 !  color first  gluon
          icolup(2,ig1) = icl3 ! Acolor first  gluon
          icolup(1,ig2) = icl2 !  color second gluon
          icolup(2,ig2) = icl3 ! Acolor second gluon

          icolup(1,iq) = icl2  !  col from second gluon
          icolup(2,iq) = 0     ! 
          icolup(1,4)  = icl1  ! col  from first  gluon
          icolup(2,4)  = 0
       elseif(idia.eq.2) then ! u-channel
          icolup(1,ig1) = icl3 !  color first  gluon
          icolup(2,ig1) = icl1 ! Acolor first  gluon
          icolup(1,ig2) = icl3 !  color second gluon
          icolup(2,ig2) = icl2 ! Acolor second gluon

          icolup(1,iq) = icl1  ! col from first gluon 
          icolup(2,iq) = 0     ! 
          icolup(1,4) =  icl2  ! col  from second gluon
          icolup(2,4) = 0
       endif 
      ELSEIF(idup(4).eq.-6) then ! Tbar
       if(idia.eq.1) then ! t-channel
          icolup(1,ig1) = icl3 !  color first  gluon
          icolup(2,ig1) = icl1 ! Acolor first  gluon
          icolup(1,ig2) = icl3 !  color second gluon
          icolup(2,ig2) = icl2 ! Acolor second gluon

          icolup(1,iq) = 0     ! 
          icolup(2,iq) = icl2  ! Acol from second gluon
          icolup(1,4)  = 0
          icolup(2,4)  = icl1  ! Acol from first  gluon
       elseif(idia.eq.2) then ! u-channel
          icolup(1,ig1) = icl1 !  color first  gluon
          icolup(2,ig1) = icl3 ! Acolor first  gluon
          icolup(1,ig2) = icl2 !  color second gluon
          icolup(2,ig2) = icl3 ! Acolor second gluon

          icolup(1,iq) = 0     ! 
          icolup(2,iq) = icl1  ! Acol from first gluon 
          icolup(1,4 ) = 0     ! 
          icolup(2,4) =  icl2  ! Acol  from second gluon
       endif 

      ENDIF
**
*      print*,'**********************'
*      do I = 1, Nup
*       print*,'I ',I,' is KF',idup(i),' MOT ',
*     & mothup(1,i),mothup(2,i),' COL ',icolup(1,I),icolup(2,i)
*      enddo
 
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
        ntop = ntop + 1
        kpp(ntop) = I
        kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       else 
        print*,' NO top is found. Stop run'
        STOP ! no top quark
       endif
      return
      end
