*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky    06.09.2002                                * 
      subroutine colorf_t_q2f(it) 
*     ---------------------------                                            *
*  fill information about color flow for three-body top decay                *
*      t -> q W/H/Z (-> NU L+-, U D~, L- L+)                                 * 
* positions in HEPEUP list are as follows:                                   *
*    (hard process) V(W,H+-,Z) q f1 f2~                                      *
* input :                                                                    * 
*  IT is position of parent top in HEPEUP list                               *
*  fc(1) and fc(2) are KF codes of the first and second fermions from boson  *
* internal :                                                                 *
*  IQ, IV, IL1, IL2 are positions in HEPEUP list of the final particles:     *
*  q-quark, V-boson, and two final fermions from V-boson decay               *
*............................................................................*
      implicit none
*
      include "txpar.inc"     
      include "hepeup.inc" 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer it, IV, IQ, IL1, IL2, fc1, fc2  
*.....
      IV   = NUP + 2              ! V-boson position in HEPEUP list
      kdec(1,2) = IV              ! V-boson position in HEPEUP list
      istup(IV) = 2               ! will be not treated by PYTHIA
      mothup(1,IV) = IT           ! mother is top 
      mothup(2,IV) = IT           ! mother is top 
      idup(iV)     = kdec(1,1)    ! KF code of the V-boson
*... 
      IQ = NUP + 1                ! color flow (top => q)
      kdec(2,2) = IQ              ! Q position in HEPEUP list
      istup(IQ)    = 1
      mothup(1,IQ) = IT           ! mother is top 
      mothup(2,IQ) = IT           ! mother is top 
      idup(iQ)     = kdec(2,1)    ! KF code of the final quark
      icolup(1,IQ) = icolup(1,IT) ! color flow is identical
      icolup(2,IQ) = icolup(2,IT) ! to top quark
*....
       IL1 = NUP + 3                       ! U(nu) 
       IL2 = NUP + 4                       ! D(l+-)
       kdec(3,2) = IL1                     ! U(nu)  position in HEPEUP list
       kdec(4,2) = IL2                     ! D(L+-) position in HEPEUP list
       fc1 = kdec(3,1)                     ! KF code
       fc2 = kdec(4,1)                     ! KF code
       call colorf_BFF(IV, IL1, FC1, IL2, FC2) 

      call DECHEP(IT, 1, IV) 
      call DECHEP(IT, 2, IQ) 
      call DECHEP(IT, 3, IL1) 
      call DECHEP(IT, 4, IL2) 
        NUP = NUP + 4        
*
      return
      end
