c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky    03.02.2001                                * 
      subroutine colorf_t_qht(it) 
*     --------------------------------------------------------               *
*  fill information about color flow for five-body top decay                 *
*      t -> B H* (Bbar T* (-> B W* (-> NU L+-, U D~)                         * 
* input :                                                                    * 
*  IT is position of parent top in HEPEUP list                               *
*............................................................................*
      implicit none
*
      include "txpar.inc"     
      include "hepeup.inc" 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer it, NL1, NL2, fc1, fc2, nb1, nb2, nh, nbar1, nw, iz  
*.....
* top[ipt] -> B2[nb2] + H+- 
*                     H+- -> Bbar1[Nbar1] t*
*                                         t* -> W[NW] B1[nb1] nu[NL1] L+[NL2]  
*
      Nb2   = NUP + 1  ! position of B2   from initial top
      NH    = NUP + 2  ! position of H+- 
      Nbar1 = NUP + 3  ! position of Bbar from H+- 
      NW    = NUP + 4  ! position of W    from top    
      Nb1   = NUP + 5  ! position of B1   from second (virtual) top    
      NL1   = NUP + 6  ! position of nu   from W 
      NL2   = NUP + 7  ! position of L+-  from W 
* B2 (from top) 
      istup(nb2)    = 1
      mothup(1,nb2) = IT           ! mother is top 
      mothup(2,nb2) = IT           ! mother is top 
      idup(nb2)     = kdec(1,1)    ! KF code of the final B2-quark
      icolup(1,nb2) = icolup(1,IT) ! color flow is identical
      icolup(2,nb2) = icolup(2,IT) ! to top quark
      iz = idup(it)/abs(idup(it))  ! +1 for top and H+, -1 for antipart.
* H+- 
      istup(NH)    = 2
      mothup(1,NH) = IT           ! mother is top 
      mothup(2,NH) = IT           ! mother is top 
      idup(NH)     = kdec(2,1)    ! KF code of the H+-
      icolup(1,NH) = 0
      icolup(2,NH) = 0
* for Bbar from H+-
      istup(Nbar1) = 1     
      mothup(1,Nbar1) = NH        ! mother is H+-
      mothup(2,Nbar1) = NH        ! mother is H+- 
      idup(nbar1)     = kdec(3,1) 
       IPAR(50) = IPAR(50) + 100  ! new current color
      icolup(1,nbar1) = (ipar(50)+1)*(1-iz)/2
      icolup(2,nbar1) = (ipar(50)+1)*(1+iz)/2
* for W from second top 
      istup(NW) = 2     
*      idup(NW) = 2      
      mothup(1,NW) = NH           ! mother is H+-
      mothup(2,NW) = NH           ! mother is H+- 
      idup(NW)     = kdec(5,1) 
* for B1 from second top 
      istup(Nb1) = 1     
      mothup(1,Nb1) = NH          ! mother is H+-
      mothup(2,Nb1) = NH          ! mother is H+- 
      idup(Nb1)     = kdec(6,1) 
      icolup(1,nb1) = (ipar(50)+1)*(1+iz)/2
      icolup(2,nb1) = (ipar(50)+1)*(1-iz)/2
*
      fc1 = kdec(7,1) 
      fc2 = kdec(8,1) 
      call colorf_BFF(nw, NL1, fc1, NL2, fc2) 
* boost to initial hadron ref. frame
      call DECHEP(IT, 1, nb2  ) ! B2 
      call DECHEP(IT, 2, NH   ) ! H+- 
      call DECHEP(IT, 3, NBar1) ! Bbar1 
      call DECHEP(IT, 5, NW   ) ! W 
      call DECHEP(IT, 6, NB1  ) ! B1
      call DECHEP(IT, 7, NL1  ) ! NU or U
      call DECHEP(IT, 8, NL2  ) ! L+- or Dbar
*  increase NUP
      NUP = NUP + 7        
*
      return
      end
