*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  25.12.2003                                  *
      Subroutine Dirs_Vbar(P, V) 
*     --------------------------                                             *
*  two solutions of Dirac equations, Vbar-spinors (rows)                     *
*... input                                                                   *
*  P(5) is fermion's momentum                                                *
*... Output : V-spinors (column),   V(2,4)  are two solutions                *
*............................................................................*

      implicit None
      double complex ei 
      data ei/(0.d0, 1.d0)/
      double complex V(2,4), PP, PM, P1, P2
      double precision P(5), NR 
      integer i,j
*
       do i = 1,2
        do j = 1,4
         V(i,j) = (0.d0, 0.d0)
        enddo
       enddo
      NR = dsqrt(2.d0 * (p(5) + p(4)))
       Pp = (p(5) + p(4) + p(3)) / nr
       Pm = (p(5) + p(4) - p(3)) / nr
       p1 = (p(1) + ei * p(2)  ) / nr
       p2 = (p(1) - ei * p(2)  ) / nr
*  Vbar-spinors, rows
       V(1,1) = -p1
       V(1,2) =  pp 
       V(1,3) = -p1
       V(1,4) = -pm 
        V(2,1) = -pm
        V(2,2) =  p2
        V(2,3) =  pp 
        V(2,4) =  p2
      return
      end
