*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  19/11/2006                                  *
*  complex matrix element for the process                                    *
*  G  G  --> t(pol)  + t_bar(pol)                                            *
* we calculate in t tbar center of mass system!
*----------------------------------------------------------------------------*
      subroutine ggttbar(q1, q2, p1, p2, hh, ves)
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc" 
      double precision q1(5), q2(5)   ! momenta of initial gluons 
      double precision p1(5), p2(5)   ! momenta of final t and tbar 
      DOUBLE COMPLEX ei   
      data ei/(0.d0, 1.d0)/
      double precision Ves, coef, zn1, zn2
      COMMON /colden/ zn1, zn2
      double precision         pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision S, SCALP,sqr,pp1(5),pp2(5),ptt(5)
      double precision hh0, hh(3,3), tm1, tm2 
      Integer I1, I2, j1,j2
      double complex T1, T2,  
     & UVex, UVey, UVq1, UVq2, UVq1exy, UVq2exy, F0 
      double complex b1(2,2,2,2), b2(2,2,2,2), U(2,4), V(2,4) 
c      double precision ZM11, ZM12, ZM21, ZM22
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
*
      if(first) THEN
        coef = (4.d0 * pi)**2                     ! due to alpha_s
        coef = coef * rpar(10)                    ! transform into millibarns
        coef = coef / (8.d0 * 8.d0 * 2.d0 * 2.d0) ! colors & spins
        coef = coef / 3.d0                        ! color normalization
        first=.FALSE.
      ENDIF

      S   = 2.d0 * SCALP(q1, q2)
      ZN1 = 2.d0 * SCALP(p1, q1)
      ZN2 = 2.d0 * SCALP(p1, q2)
* boost to QQbar rest frame
      sqr = dsqrt(s)
       do i1 = 1,4
        ptt(i1) = p1(i1) + p2(i1)
       enddo
       ptt(5) = dsqrt(scalp(ptt, ptt))
       call lorenf_s(ptt, p1, pp1)
       call lorenf_s(ptt, p2, pp2)
* pp1 and pp2 are in QQbar rest frame

      call Dirs2_Ubar(pp1, U) 
      call Dirs2_V   (pp2, V) 

      Tm1 = 0.d0
      Tm2 = 0.d0
*  b(i1,i2,j1,j2) i1,i2 are final fermion's indexes
*                 j1,j2 are initial gluon's indexes

      do 990 i1 = 1,2
      do 990 i2 = 1,2
      do 990 j1 = 1,2
      do 990 j2 = 1,2
       b1(i1,i2,j1,j2) = (0.d0,  0.d0)
 990   b2(i1,i2,j1,j2) = (0.d0,  0.d0)


      do 999 i1 = 1,2
      do 999 i2 = 1,2
       if(ipar(33).eq.0.or.ipar(33).eq.1) goto 991
       if(ipar(33).eq.4.and.i1.eq.1.and.i2.eq.1) goto 991
       if(ipar(33).eq.5.and.i1.eq.1.and.i2.eq.2) goto 991
       if(ipar(33).eq.6.and.i1.eq.2.and.i2.eq.1) goto 991
       if(ipar(33).eq.7.and.i1.eq.2.and.i2.eq.2) goto 991
        goto 999
 991   continue
* e_x:  Ubar [ e_x ] V 
      UVex = +U(i1,1)*V(i2,4) + U(i1,2)*V(i2,3)
     &       -U(i1,3)*V(i2,2) - U(i1,4)*V(i2,1)  
* e_y:  Ubar [ e_y ] V 
      UVey = -U(i1,1)*V(i2,4) + U(i1,2)*V(i2,3)
     &       +U(i1,3)*V(i2,2) - U(i1,4)*V(i2,1)  
      UVey = ei * UVey
* Ubar [ q1 ] V
      UVq1 = sqr * ( U(i1,1)*V(i2,3) + U(i1,4)*V(i2,2))
      UVq2 = sqr * ( U(i1,2)*V(i2,4) + U(i1,3)*V(i2,1))
* Ubar [ q1 e_x e_y ] V
      UVq1exy = ei*sqr * (-U(i1,1)*V(i2,3) + U(i1,4)*V(i2,2))
      UVq2exy = ei*sqr * ( U(i1,2)*V(i2,4) - U(i1,3)*V(i2,1))

      F0 = -U(i1,1)*V(i2,3) + U(i1,2)*V(i2,4)
     &     +U(i1,3)*V(i2,1) - U(i1,4)*V(i2,2)  
      F0 = sqr * F0
* g_1(1) + g_2(1)
      T1 = (-2.d0*pp1(1)*UVex - UVq1) / zn1
     &   + (-2.d0*pp1(1)*UVex - UVq2) / zn2
      T2 = (-2.d0*pp1(1)*UVex - UVq1) / zn1
     &   - (-2.d0*pp1(1)*UVex - UVq2) / zn2
     &   - 2.d0 * F0 / s
       b1(i1,i2,1,1) = T1
       b2(i1,i2,1,1) = T2
       tm1 = tm1 + T1 * conjg (T1)
       tm2 = tm2 + T2 * conjg (T2)
* g_1(1) + g_2(2)
      T1 = (-2.d0*pp1(1)*UVey + UVq1exy) / zn1 
     &   + (-2.d0*pp1(2)*UVex - UVq2exy) / zn2
      T2 = (-2.d0*pp1(1)*UVey + UVq1exy) / zn1 
     &   - (-2.d0*pp1(2)*UVex - UVq2exy) / zn2
       b1(i1,i2,1,2) = T1
       b2(i1,i2,1,2) = T2
       tm1 = tm1 + T1 * conjg (T1)
       tm2 = tm2 + T2 * conjg (T2)
* g_1(2) + g_2(1)
      T1 = (-2.d0*pp1(2)*UVex - UVq1exy) / zn1
     &   + (-2.d0*pp1(1)*UVey + UVq2exy) / zn2
      T2 = (-2.d0*pp1(2)*UVex - UVq1exy) / zn1
     &   - (-2.d0*pp1(1)*UVey + UVq2exy) / zn2
       b1(i1,i2,2,1) = T1
       b2(i1,i2,2,1) = T2
       tm1 = tm1 + T1 * conjg (T1)
       tm2 = tm2 + T2 * conjg (T2)
* g_1(2) + g_2(2)
      T1 = (-2.d0*pp1(2)*UVey - UVq1) / zn1
     &   + (-2.d0*pp1(2)*UVey - UVq2) / zn2
      T2 = (-2.d0*pp1(2)*UVey - UVq1) / zn1
     &   - (-2.d0*pp1(2)*UVey - UVq2) / zn2
     &     - 2.d0 *  F0 / s
       b1(i1,i2,2,2) = T1
       b2(i1,i2,2,2) = T2
      tm1 = tm1 + T1 * conjg (T1)
      tm2 = tm2 + T2 * conjg (T2)
 999  continue  

      hh0 = 7.d0*TM1 + 9.d0*TM2

       do 956 j1 = 1,3
       do 956 j2 = 1,3
 956     hh(j1,j2) = 0.d0

       do 988 i1 = 1,2
       do 988 i2 = 1,2
* hh(1,1) xx
        T1 = b1(1,1,i1,i2) + b1(2,1,i1,i2)  
     &     - b1(1,2,i1,i2) - b1(2,2,i1,i2) 
        T2 = b2(1,1,i1,i2) + b2(2,1,i1,i2)  
     &     - b2(1,2,i1,i2) - b2(2,2,i1,i2) 
       hh(1,1) = hh(1,1) +       7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2)
* hh(2,1) : yx
        T1 = b1(1,1,i1,i2) - b1(1,2,i1,i2)  
     & - ei*(b1(2,1,i1,i2) - b1(2,2,i1,i2)) 
        T2 = b2(1,1,i1,i2) - b2(1,2,i1,i2)  
     & - ei*(b2(2,1,i1,i2) - b2(2,2,i1,i2)) 
       hh(2,1) = hh(2,1)  +      7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2)
* hh(3,1) : zx
        T1 = b1(1,1,i1,i2) - b1(1,2,i1,i2) 
        T2 = b2(1,1,i1,i2) - b2(1,2,i1,i2)  
       hh(3,1) = hh(3,1) + 2.d0*(7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2))
* hh(1,2) : xy
        T1 = b1(1,1,i1,i2) + b1(2,1,i1,i2)  
     & - ei*(b1(1,2,i1,i2) + b1(2,2,i1,i2)) 
        T2 = b2(1,1,i1,i2) + b2(2,1,i1,i2)  
     & - ei*(b2(1,2,i1,i2) + b2(2,2,i1,i2)) 
       hh(1,2) = hh(1,2)  +      7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2)
* hh(2,2) : yy
        T1 = b1(1,1,i1,i2) - b1(2,2,i1,i2)  
     & - ei*(b1(1,2,i1,i2) + b1(2,1,i1,i2)) 
        T2 = b2(1,1,i1,i2) - b2(2,2,i1,i2)  
     & - ei*(b2(1,2,i1,i2) + b2(2,1,i1,i2)) 
       hh(2,2) = hh(2,2)  +      7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2)
* hh(3,2) :zy
        T1 = b1(1,1,i1,i2) - ei*b1(1,2,i1,i2) 
        T2 = b2(1,1,i1,i2) - ei*b2(1,2,i1,i2)
       hh(3,2) = hh(3,2) + 2.d0*(7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2))
* hh(1,3) :xz
        T1 = b1(1,2,i1,i2) + b1(2,2,i1,i2)
        T2 = b2(1,2,i1,i2) + b2(2,2,i1,i2)
       hh(1,3) = hh(1,3) + 2.d0*(7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2))
* hh(2,3) : yz
        T1 = b1(1,2,i1,i2) - ei*b1(2,2,i1,i2)
        T2 = b2(1,2,i1,i2) - ei*b2(2,2,i1,i2)
       hh(2,3) = hh(2,3) + 2.d0*(7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2))
* hh(3,3) : zz
        T1 = b1(1,2,i1,i2) 
        T2 = b2(1,2,i1,i2) 
       hh(3,3) = hh(3,3) + 4.d0*(7.d0*T1*conjg(T1)+9.d0*T2*conjg(T2))
 988   continue
      do i1 = 1,3
      do i2 = 1,3
       hh(i1,i2) = (hh(i1,i2) - hh0) / hh0
      enddo
      enddo
c      write(*,*) '*****'
c      write(*,121) (hh(1,i1),i1=1,3)
c 121  format(' XX XY XZ ',3(f10.4,1x))
c      write(*,122) (hh(2,i1),i1=1,3)
c 122  format(' YX YY YZ ',3(f10.4,1x))
c      write(*,123) (hh(3,i1),i1=1,3)
c 123  format(' ZX ZY ZZ ',3(f10.4,1x))
      ves = coef * rpar(15)**2 * hh0 
      return
      end
