c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky                  09.01.2001                  *
      subroutine LIPS3(Q, p1, p2, p3, Wt)                                   
*     -----------------------------------                                    *
*                                                                            *
*   calculate  Lorentz invariant phase space  of 3 particles                 *
*   input  : Q -> p1 p2 p3                                                   *
*   output : p1, p2, p3 are momenta of final particle                        *
*............................................................................*

      implicit none
      double precision Q(5), p1(5),p2(5),p3(5), pc(5)
      double precision WT, WC, m0, del, PYR
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
      m0 = p1(5) + p2(5) + p3(5)
      del = (Q(5) - m0)*(Q(5) + m0 - 2.d0 * p3(5))
      pc(5) = dsqrt( (m0-p3(5))**2 + del * pyr(0))   
      call LIPS2(Q,  p3, pc, WT)
      call LIPS2(pc, p1, p2, WC) 
      WT = WT * WC * pi2_3 * del 
      return
      end
