*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky                  09.01.2001                  *
      subroutine LIPS3_TTG(Q, PT0, p1, p2, p3, Wt)                             
*     -----------------------------------                                    *
*                                                                            *
*   calculate  Lorentz invariant phase space  of 3 particles                 *
*   input  : Q -> p1 p2 p3                                                   *
*   output : p1, p2, p3 are momenta of final particle                        *
*............................................................................*

      implicit none
      double precision Q(5), p1(5),p2(5),p3(5), pc(5)
      double precision WT, WC, m0, del 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision PYR, fi, delta,x0,xx, pp(5), pt0,
     & c3te, s3te, rp, ptt 
      integer i
* 
      wt = 0.d0
      m0 = p1(5) + p2(5) + p3(5)
      del = (Q(5) - m0)*(Q(5) + m0 - 2.d0 * p3(5))
 100  pc(5) = dsqrt( (m0-p3(5))**2 + del * pyr(0))   
*
*      call LIPS2(Q,  p3, pc, WT)

      DELTA = Q(5)**4 + p3(5)**4 + pc(5)**4 
     &-2.d0*((Q(5)*p3(5))**2+(Q(5)*pc(5))**2+(p3(5)*pc(5))**2)
       if(delta.ge.0.0d0) then
        delta = dsqrt(delta)
       else
        delta = 0.d0
       endif
      rp = delta / (2.d0 * Q(5)) 

c  calculation of p1 and p2  in the rest frame of pin
      x0 = (rp**2 - pt0**2)/pt0**2
      if(x0.le.0.d0) return
      x0 = dsqrt(x0)
      xx = pyr(0) * x0
      PTT = rp / dsqrt(1.d0 + xx**2)
      c3te = xx / dsqrt(1.d0 + xx**2)
      fi = pyr(0) 
       if(fi.ge.0.5d0) c3te = -c3te
      s3te = DSQRT(1.d0 - c3te*c3te)
      fi = 2.d0*pi*pyr(0) 
      pp(4) = (Q(5)**2 + p3(5)**2 - pc(5)**2) / (2.d0 * Q(5)) 
      pp(3) = rp*c3te
      pp(2) = rp*s3te*DSIN(fi)
      pp(1) = rp*s3te*DCOS(fi)
      pp(5) = p3(5)
       if(pp(5).GT.pp(4)) return
* now PP is momentum of 1-particle in the rest frame of Q 
      wt = 0.d0
      call lorenb_s(Q, pp, p3) ! Lorentz transformation into initial frame
        if(p3(5).gt.p3(4)) return
       do i = 1,4
        pc(i) = Q(i) - p3(i)
       end do
        if(pc(5).gt.pc(4)) return
      Wt = pi * rp / (Q(5) * pi2_6 )
      Wt = Wt * x0 * PTT**3/rp**3
*      WT = Wt * 2.d0 ! due to +/- cosTHETA
*
      call LIPS2(pc, p1, p2, WC) 
      WT = WT * WC * pi2_3 * del 
      return
      end
