c----------------------------------------------------------------------------c

*.. author : Serge Slabospitsky   24.10.99                                   *
*....                                                                        * 
      subroutine LIPS_Res_Wff(R, pq, pl, pn, Ves)
*     -------------------------------------------                            *
*                                                                            *
*  calculation of the dLIPS_3 with denominator due to W-boson                *
*                                                                            *
*                R3(R, Pq, Pl, Pn)                                           *
*    --------------------------------------------                            *
*    [ (p_w**2 - m_W**2)**2 + (Gamma_W * m_W)**2]                            *
*                                                                            *
*     R -> q   W (-> el nu)                                                  *
*     R    Pq  Pw    Pl Pn                                                   *
*... input :                                                                 *
*  R   is  5-momentum of initial system                                      *
*    lepton and neutrino denoted the two final fermions resulted from        *
*    from W-boson decay                                                      *
*... output :                                                                *
*  Pq, Pl, and Pn are 5-momenta of final quark, lepton, and neutrino         *
*  ves is the weight                                                         * 
*............................................................................*

      implicit none
      double precision R(5), Pq(5), Pl(5), Pn(5)
      include "txpar.inc" 
      double precision et0, Dew
      double precision ves, Ves21, Ves22
      double precision Pw(5), PYR
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*
      et0 = atan((rpar(70)**2 - Rpar(42) ) / Rpar(44)) 
      Dew = atan( ((R(5) - Pq(5))**2 - Rpar(42))/ Rpar(44)) - et0
      pw(5) = dsqrt(Rpar(42) + Rpar(44)*tan(et0 + Dew * PYR(0))) 
      ves = pi2_3 * Dew / Rpar(44) 
      call LIPS2 (R,  Pq, Pw, ves21)
      call LIPS2 (pw, Pl, Pn, ves22)
       VES = ves * ves21 * ves22
      return
      end
