c----------------------------------------------------------------------------c
*...Author : Serge Slabospitsky     08.01.2001                               *
*...                                                                         *
      subroutine LIPSN(Q, Npp, p, Wt)
*     -----------------------------                                          *
*...                                                                         *
*...calculate N-body (N >=2) Lorentz Invariant Phase Space                   *
*    Q --> p1 p2 ... pn                                                      *
*...input  : Q is 5-vector of initial system                                 *
*            P(Np,5) masses of partricles                                    *
*...output : P(Np,5) are 5-momenta of final particles                        *
*............................................................................*
      implicit None
      double precision Q(5)
      integer NP, Npp
      double precision P(20,5), pn(5), pr(5), QR(5) 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision PYR, Wt, del, M0, ves2
      Integer I
*
      Wt = 0.d0
      NP = npp
      if(np.le.1) return 
      Wt = 1.d0
       do i = 1,5
        QR(i) = Q(i)
       enddo
      if(np.eq.2) goto 300 
*  three or more particles
       m0 = 0.d0
      do i = 1, np
       m0 = m0 + p(i,5)
      enddo 
 100  pn(5) = p(np,5)
      del = (QR(5) - M0)*(QR(5) + M0 - 2*pn(5)) 
      pr(5) = dsqrt( (m0-pn(5))**2 + del * PYR(0))
       call LIPS2(QR, pn, pr, ves2)
      wt = wt * ves2 * pi2_3 * del
       do i=1,5
        p(np,i) = pn(i)
       enddo 
       np = np - 1
        m0 = m0 - pn(5)
         do i = 1,5
          QR(i) = PR(I)
         enddo
      if(np.ge.3) goto 100
 300  continue
          pn(5) = p(2,5)
          pr(5) = p(1,5)
         call LIPS2(QR, pn, pr, ves2)
         wt = wt * ves2  
        do i=1,5
         p(2,i) = pn(i)
         p(1,i) = pr(i)
        enddo
      return
      end
