*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  24/06/2000                                  *
      subroutine mass2(p1,p2,sm2,sm)
*     -------------------------------                                        *
*                                                                            *
*    invariant mass of two 4-vectors                                         *
*    input : p1 and p2                                                       *
*    sm2 - mass**2                                                           *
*    sm  - mass, if SM2 < 0, then SM = 0                                     *
*............................................................................*

      Implicit none
      double precision p1(5), p2(5), SM2, SM 
*
      sm2 = (p1(4) + p2(4))*(p1(4) + p2(4))
     &    - (p1(1) + p2(1))*(p1(1) + p2(1))
     &    - (p1(2) + p2(2))*(p1(2) + p2(2))
     &    - (p1(3) + p2(3))*(p1(3) + p2(3))
      if(sm2.lt.0d0) then
       SM = 0d0
      else
       SM = DSQRT(SM2)
      endif
      return
      end
