*----------------------------------------------------------------------------*
*... Author  :  Serge Slabospitsky                                           *
*... 22/11/99                                                                *
*... modified 15.08.2005                                                     *
*... abs(pnu1(3)) <= abs(pnu2(3))                                            *
c----------------------------------------------------------------------------*

      Subroutine NeutZ0(iv, nut, pl, pnu1, pnu2, pw1, pw2)

      implicit none
      include "txpar.inc" 
      double precision MV, MV2 ! m**2 of V-boson
      double precision nut(5), pl(5), pnu1(5), pnu2(5), pw1(5), pw2(5)
      double precision mt2, lt2, nt2, d, z1, z2
      integer i, iv
*
      if(iv.eq.23) then
       mv  = Rpar(45)
       mv2 = Rpar(46) ! Z-boson
      elseif(iv.eq.24) then
       mv  = Rpar(41)
       mv2 = Rpar(42) ! W-boson
      else
       print*,'Neutz: wrong IV = ',iv,' should be 23 or 24 '
       pnu1(4) = -10.d0
       pnu2(4) = -10.d0
      endif
      mt2 = mv2 / 2. + nut(1)*pl(1) + nut(2)*pl(2) 
      lt2 = pl(1)*pl(1) + pl(2) *pl(2)
      nt2 = nut(1)**2 + nut(2)**2

      d = mt2*mt2 - lt2*nt2
       if(d.lt.0.0) then
*         no solutions. May be too high P_T of neutrino
        pnu1(4) = -10.
        return
       else
        d = sqrt(mt2*mt2 - lt2*nt2)
       endif
      z1 = (mt2*pl(3) + pl(4)*d)/lt2
      z2 = (mt2*pl(3) - pl(4)*d)/lt2
        if(abs(z1).lt.abs(z2)) then
         pnu1(3) = z1
         pnu2(3) = z2
        else
         pnu1(3) = z2
         pnu2(3) = z1
        endif

       pnu1(4) = sqrt(nt2 + pnu1(3)**2)
       pnu2(4) = sqrt(nt2 + pnu2(3)**2)
      do i = 1,2
       pnu1(i) = nut(i)
       pnu2(i) = nut(i)
      enddo                  
       pnu1(5) = 0.d0
       pnu2(5) = 0.d0
       do i = 1,4
        pw1(i) = pnu1(i) + pl(i)
        pw2(i) = pnu2(i) + pl(i)
       enddo
        pw1(5) = mv
        pw2(5) = mv
      return
      end
