c----------------------------------------------------------------------------c
*... authors: Lars Sonnenschein   and Serge Slabospitsky 27/02/2001          *
      subroutine Res_branch (IT, kf, idc) 
*     -------------------------------------                                  *
* returns No. of resonance decay mode  (see PYTHIA)                          * 
* We consider the case of FACTORIZED  resonance  decays                      *
* Input:  kf is KF code of resonance                                         *
* Output: IDC  is Individual Decay Channel                                   *
*............................................................................*
      Implicit none
      double precision PYR
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IT  = 1 : top quark,  IT = 2(5)  : W-boson, 
*     IT  = 3 : H+- boson,  IT = 4     : Z-boson 
* mid(0, i) is NIDCmax, i.e. max. number of decay channels
*
      include "txpar.inc" 
*...........
      integer IT, kf, idc, J, N1 
      double precision Brnd 
      double precision  BRHT 
      double precision Hgw !,    brtqw  ! additional BR
      common /HTdecp/  Hgw(2) !, brtqw(0:2) 
*.....
      if(IT.eq.1) goto 101    ! top quark
      if(IT.eq.3) goto 103    ! H+- boson
      if(kf.gt.0) then
       Brnd = BRS(1, IT)
       n1   = 2 
      else
       Brnd = BRS(2, IT) 
       n1   = 3 
      endif
      Brnd = Brnd*pyr(0) 
       do J = 1, MID(0, IT)
        if(Mid(J, IT).EQ.1.OR.Mid(J, IT).EQ.N1) then 
           BRND = BRND - BRF(J, IT)
        endif 
         IF (BRND.LE.0.0d0) goto 311
        enddo 
      if(J.gt.mid(0, IT)) then
       print*,'   RES_branch: IDC exhausted. Stop running'
       STOP 
      endif
 311    continue
      idc = J
      return
******--------- TOP-quark decay channles 
 101  if(kf.gt.0) then
       Brnd = BRS(1,IT)   ! top 
       n1   = 2 
      else
       Brnd = BRS(2,IT)   ! topbar
       n1   = 3 
      endif
      if(BRND.le.0.0d0) then
       write(*,1221) 
 1221  format('   total BR for top quark less than 0: stop running')
       STOP
      endif
      Brnd = Brnd*pyr(0) 

       do J = 1, MID(0, IT)
        if(MID(J, IT).eq.-1) goto 749
          BRHT = BRF(J, IT)
           if(J.eq.1.or.J.eq.2.or.J.eq.3)
     &                           BRHT = BRHT * BRS((n1-1),2)
           if(J.eq.5)            BRHT = BRHT * Hgw(n1-1)
           if(J.eq.6)            BRHT = BRHT * BRS((n1-1),2)
           if(J.eq.15.or.J.eq.16.or.J.eq.17.or.J.eq.18) 
     &                           BRHT = BRHT * BRS(1,4) 
        if(Mid(J, IT).EQ.1.OR.Mid(J, IT).EQ.N1) then 
           BRND = BRND - BRHT 
        endif 
         IF (BRND.LE.0.d0) goto 312
 749     continue
        enddo 
      if(J.gt.mid(0, IT)) STOP 
 312  continue
      idc = J
      return
*******------- H+- boson decay channels
 103  if(kf.gt.0) then
       Brnd = BRS(1,IT)   ! H+ boson 
       n1   = 2 
      else
       Brnd = BRS(2,IT)   ! H- boson 
       n1   = 3 
      endif
      if(BRND.le.0.d0) then
       write(*,1222) 
 1222  format('   total BR for H+- boson less than 0: stop running')
       STOP
      endif
      Brnd = Brnd*pyr(0) 
       do J = 1, MID(0, IT)
           BRHT = BRF(J, IT)
           if(J.eq.11) BRHT = BRHT * BRS((n1-1), 2)  ! due to W-boson
        if(Mid(J, IT).EQ.1.OR.Mid(J, IT).EQ.N1) then 
           BRND = BRND - BRHT 
*           BRND = BRND - BRF(J, IT)
        endif 
         IF (BRND.LE.0.d0) goto 314
        enddo 
      if(J.gt.mid(0, IT)) STOP 
 314  continue
      idc = J
      return

      end
