*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  14.06.2004                                  *
*  calculates dLIPS4 with denominator                                        *
*  R -> pZ(f1, f2) f3 f4                                                     *
*  ONE denominator is  included                                              *
*  the denominator is (pZ^2-M_Z^2)^2 + (M_Z * Width_Z)^2  due to Z-boson     *
*............................................................................*
      subroutine Rlip42(R, k1, k2, k3, k4, pz, wtR)
*     -------------------------------------------                            *
      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision R(5), k1(5), k2(5), k3(5), k4(5), pz(5), pqq(5)
      include "txpar.inc" 
      double precision plim(2), ves, p2s, wtR, del, pyr 

      plim(1) = rpar(79) 
        if(plim(1).lt.(k1(5)+k2(5))) then
           plim(1) = k1(5)+k2(5)
        endif          
        plim(2) = min(rpar(80), ( R(5) - rpar(77))) 
       wtR = 0.d0
       if(plim(1).ge.plim(2)) return
      call brtwig(plim, rpar(45), rpar(48), ves, p2s)
      wtR = ves 
       pz(5) = p2s
      del = min(rpar(78), (R(5) - p2s)) / Rpar(77)
      pqq(5) = rpar(77) * del ** pyr(0)
      call Lips2(R,  pz, pqq, ves)
      wtR = wtR * ves * 4.d0 * pqq(5)**2 * dlog(del)
      call Lips2(pz, k1, k2, ves)
      wtR = wtR * ves 
      call Lips2(pqq, k3, k4, ves)
      wtR = pi2_3 * pi2_3 * wtR * ves 
      wtR = wtR * ( (rpar(46) - p2s**2)**2 + Rpar(48)**2)
      return
      end
