*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  09.07.2001                                  *
      subroutine Rlip43(R, b1, b2, pl, pn, wtR)
*     -------------------------------------------                            *
*  calculates dLIPS with denominator                                         *
*  R -> pw( el nu) q (-> B1 B2)                                              *
*  two denominators are included                                             *
*  one is    (q**2)      due to gluon splitting into q1 q2                   *
*  second is (pw^2-M_W^2)^2 + (M_W * Width_W)^2  due to W-boson              *
*............................................................................*
      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision R(5), pq(5), b1(5), b2(5), PL(5), PN(5), pw(5)
      include "txpar.inc" 
*  rpar(70) = MW_min  is  min (e+ nu) mass
      double precision amel, amnu 
      data amel /0./, amnu /0./     !  e+ and nu masses
      double precision t0, wtR, dew, deq, ves 
      double precision PYR
      double precision q0, qt0
*
      q0 = rpar(77) 
      t0 = datan(  (rpar(70)**2 - Rpar(42))/ Rpar(44))
      dew = datan(((R(5) - q0 )**2 - Rpar(42))/ Rpar(44)) - t0 
       pw(5) = dsqrt(Rpar(42) + Rpar(44)*dtan(t0 + dew * PYR(0))) 
      qt0 = min( rpar(78), (R(5) - pw(5)) ) / q0
      deq = 2.d0 * dlog(qt0) 
       pq(5) = q0 * (qt0)**(PYR(0)) 
      call Lips2(R,  pw, pq, wtR)
      call Lips2(pq, b1, b2, ves)
      wtR = pi2_3 *  deq * wtR * ves * pi2_3 * (dew / Rpar(44) ) 
       PL(5) = amel
       PN(5) = amnu
      call Lips2(pw,  Pl, Pn, ves)
      wtR = wtR * ves
      return
      end
