*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  09.07.2001                                  *
      subroutine Rlip432(R, pq, pb, pl, pn, wtR)
*     -------------------------------------------                            *
*  calculates dLIPS with denominator                                         *
*  R -> pw( el nu) q (-> B1 B2)                                              *
*  denominator: (pw^2-M_W^2)^2 + (M_W * Width_W)^2  due to W-boson           *
*............................................................................*
      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision R(5), pq(5), pb(5), PL(5), PN(5), pw(5)
      include "txpar.inc" 
*  rpar(70) = MW_min  is  min (e+ nu) mass
      double precision amel, amnu 
      data amel /0./, amnu /0./     !  e+ and nu masses
      double precision t0, wtR, dew, ves, PYR, q0

*
      t0 = datan(  (rpar(70)**2 - Rpar(42))/ Rpar(44))
      dew = datan(((R(5) - q0 )**2 - Rpar(42))/ Rpar(44)) - t0 
      pw(5) = dsqrt(Rpar(42) + Rpar(44)*dtan(t0 + dew * PYR(0))) 
       pq(5) = 0.d0   
       call LIPS3(R,  pw, pq, pb, wtr)                                   
       PL(5) = amel
       PN(5) = amnu
       call Lips2(pw, Pl, Pn, ves)
      wtR = wtR * ves * pi2_3 * (dew / Rpar(44) ) 
      return
      end
