*----------------------------------------------------------------------------*
*  Authors: Serge Slabospitsky                                               *
*   29.01.2001                                                               *
*  matrix element for the (W* or H*) + JET   production process              *
*  U   D~  --> G  H ( -> nu  tau+)                                           *
*  k1  k2      q         p   L                                               * 
*  denominator from propagator of W-boson or Higgs is included in LIPS       *
*............................................................................*
      subroutine sng_03(k1, k2, q, p, l, ves)

      implicit none
      include "txpar.inc" 
      double precision  k1(5), k2(5)        ! initial U and D~ quarks 
      double precision  q(5),  p(5), L(5)   ! final gluon, nu and tau
      integer I
      double precision Ves, coefH, coefW, SCALP, AM
      double precision t1, t2, t12, tn2, ct2 
      save coefW, coefH, tn2, ct2
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq1, mq2, k1k2, qk1, qk2
      double precision pk1, pk2, pq, lk1, lk2, pl, fk1,fk2, pf, qf, ql 
      double precision lv(4), vt(3,4)
      double precision f(5), mw4, mu2, tmp, f2, c4
      save mw4
*
      double precision hr 
      common /topol1/ hr(4)    ! TAU lepton polarisation vector
*
      LOGICAL first
      SAVE first
      DATA first /.TRUE./
*......... 
      IF(first) THEN        ! initializing
      first=.FALSE.
*..RPAR(26)     : g = g_weak  = e / sin(theta_W)                             *
*..Rpar(41)     : W-boson mass, Rpar(42) = Rpar(41)**2                       *
*..Rpar(55)     : tan(beta),    Rpar(56) = (1/tan(beta))                     *

       coefH = rpar(10) * 4.d0  * pi * rpar(26)**4 / Rpar(41)**4
       coefH = coefH * l(5)**2 * Rpar(55)**2
       coefW = rpar(10) * 8.d0 * pi * rpar(26)**4 
       mw4 = Rpar(42)**2
*   spin averaging is included,  alpha_s will be included below
       tn2 = Rpar(55)**2
       ct2 = Rpar(56)**2
      ENDIF
* running
      mq1 = k1(5)**2
      mq2 = k2(5)**2
      AM = mq1 * ct2 + mq2 * tn2
      k1k2 = scalp(k1, k2)
      qk1  = scalp(q, k1)
      qk2  = scalp(q, k2)

*..ipar(21)     : W-exchange: > 0 tb, <0 tau nu, 1 W, 2 H, 3 (W+H+Int)       *
      if(abs(ipar(21)).eq.2) then
* Higgs contribution     
       T1 = AM*(mq1*(k1k2-qk2)-qk1*qk2) - 2.d0*mq1*mq2*(mq1-qk1) 
       T2 = AM*(mq2*(k1k2-qk1)-qk1*qk2) - 2.d0*mq1*mq2*(mq2-qk2) 
       T12= AM*(-mq1*qk2 - mq2*qk1 - 2.d0*(qk1-k1k2)*(qk2-k1k2))
     &   + 2.d0*mq1*mq2*(2.d0*k1k2 - qk1 - qk2)
*      ves = T1/qk1/qk1 + T2/qk2/qk2 + T12/qk1/qk2

      ves = -coefH * rpar(15) * scalp(p, l)
     &    *  (T1/qk1/qk1 + T2/qk2/qk2 + T12/qk1/qk2)
      call vortas(l, vt)
        t1 = (l(5) / scalp(p, l)) 
       do I = 1,3
        hr(i) = t1 * (vt(i,4)*p(4) - vt(i,1)*p(1) 
     &             -  vt(i,2)*p(2) - vt(i,3)*p(3))
       enddo
        hr(4) = 0.d0
      elseif(abs(ipar(21)).eq.1) then
* W-boson contribution WITHOUT interference !!!
      lk1 = scalp(l, k1)
      lk2 = scalp(l, k2)
      ql  = scalp(q, L)
      pk1 = scalp(p, k1)
      pk2 = scalp(p, k2)
      pq  = scalp(p, q)
      pl  = scalp(p, l)
      mu2 = L(5)**2
       do I = 1,4
        F(I) = p(I) + L(I)
       enddo
        F2 = f(4)**2-f(1)**2-f(2)**2-f(3)**2
        f(5) = dsqrt(f2)
      fk1 = scalp(f, k1)
      fk2 = scalp(f, k2)
      pf  = scalp(p, f) 
      qf  = scalp(q, f)
*
      T1 = 2.d0*pk2 * ql  
     & -(mu2/Rpar(42))*(k1k2*pq + qk1*pk2 - qk2*pk1)
     & +(mu2/mw4)*qk1*k1k2*pl
      T1 = -T1 / qk1
* polarisation vector
      do I = 1,4
       tmp = 2.d0*pk2*q(I) 
     & -(1.d0/Rpar(42)) 
     &    * ( f2*pk2*q(I)
     &      + p(I) *(mu2*qk2 - 2.d0*ql*fk2) 
     &      - k2(I)*(f2 *pq  - 2.d0*pf*qf )  ) 
     & -(mu2/mw4)*qk1*k1k2*p(I) 
       lv(I) = -L(5)*tmp / qk1
      enddo

      T2 = 2.d0*pq * lk1 
     & -(mu2/Rpar(42))*(k1k2*pq + qk2*pk1 - qk1*pk2)
     & +(mu2/mw4)*qk2*k1k2*pl
      T2 = -T2 / qk2
* polarisation vector
      do I = 1,4
       tmp = 2.d0*pq*k1(I) 
     & -(1.d0/Rpar(42)) 
     &    * ( f2*pq*k1(I)
     &      + p(I) *(mu2*qk1 - 2.d0*lk1*qf) 
     &      - q(I) *(f2 *pk1 - 2.d0*pf*fk1)  ) 
     & -(mu2/mw4)*qk2*k1k2*p(I) 
       lv(I) = lv(I) - L(5)*tmp / qk2
      enddo

      C4 = pk2*(qk1 + qk2 - 2.d0*k1k2) + pq*k1k2 - pk1*qk2
      T12 = 2.d0*(k1k2*pk2*ql - qk1*pk2*lk2) + 2.d0*C4*lk1
     &-(mu2/Rpar(42)) * (qk1*qk2*pk1 + qk1*qk2*pk2
     &  + k1k2*pq*qf - qk1*qk1*pk2 - qk2*qk2*pk1)
     &+(2.d0*mu2/mw4)*qk1*qk2*k1k2*pl
      T12 = T12 / qk1 / qk2
* polarisation vector
      do I = 1,4
       tmp = k1k2*pk2*q(I) - qk1*pk2*k2(I) + C4 * k1(I) 
       tmp = 2.d0*tmp - (1.d0/Rpar(42)) * ( 
     & 2.d0*qk1*qk2*( pl*q(I) - (mu2+ql)*p(I))
     & + qf * ( f2*pk2*k1(I)
     &      + p(I) *(mu2*k1k2 - 2.d0*lk1*fk2) 
     &      - k2(I)*(mu2*pk1  - 2.d0*pl*lk1 )  ) )    
     & -(2.d0*mu2/mw4)*qk1*qk2*k1k2*p(I) 
       lv(I) = lv(I) + L(5)*tmp / qk1 / qk2
      enddo

      ves = -coefW * rpar(15) * (T1 + T2 + T12)

      call vortas(l, vt)
      do I = 1,3
       hr(I) = -(1.d0 / (T1 + T2 + T12))  
     & * (vt(i,4)*lv(4)-vt(i,1)*lv(1)-vt(i,2)*lv(2)-vt(i,3)*lv(3))
      enddo
       hr(4) = 0.d0 
      ELSE
       print*, '  STOP running : not implemented ipar(21) = ',ipar(21) 
       STOP
      ENDIF

      if(ipar(33).eq.2) ves = ves * (1.d0-hr(3))/2.d0
      if(ipar(33).eq.3) ves = ves * (1.d0+hr(3))/2.d0

      return
      end
