*----------------------------------------------------------------------------*
*  author : Serge Slabospitsky   30.05.2006                                  *
*  matrix element for FCNC top production:  2 -> 1                           *
*  g(p1)  U/C(p2) --> t* -> b W* -> b(p3) L+(p5) nu(p4)                      *
*  averaged on initial spins and colors                                      *
*............................................................................*

      subroutine tfcnc_00(iu, pg, ptop, ves, hv)
      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  pg(5), ptop(5)   ! momenta of initial gluon and u-quark
      double precision  mt 
      double precision Ves, coef 
      integer iu, iqf, j
*
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
*......... 
      double precision hv(4), sp(4), sq, vh(3,4)
      double precision H0(2), X0(2), B0(2), AH(2), AX(2), AB(2)
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
*..RPAR(10)     : 0.38939d0     transformation 1/GeV**2 to mb                *
*............................................................................*
      IF(first) THEN        ! initializing
       coef = rpar(10) 
       coef = coef / (3.d0 * 8.d0 * 2.d0) 
       first=.FALSE.
       do j = 11,12
        iqf = j - 10
        H0(iqf) = HR(j)*conjg(HR(j)) + HL(j)*conjg(HL(j))
        X0(iqf) = XR(j)*conjg(XR(j)) + XL(j)*conjg(XL(j))
        B0(iqf) = HL(j)*conjg(XL(j)) + XL(j)*conjg(HL(j))
     &          + HR(j)*conjg(XR(j)) + XR(j)*conjg(HR(j))
*
        AH(iqf) = HL(j)*conjg(HL(j)) - HR(j)*conjg(HR(j))
        AX(iqf) = XL(j)*conjg(XL(j)) - XR(j)*conjg(XR(j))
        AB(iqf) = HL(j)*conjg(XL(j)) + XL(j)*conjg(HL(j))
     &          - HR(j)*conjg(XR(j)) - XR(j)*conjg(HR(j))
       enddo
      ENDIF
        iqf = 0
        if(iu.eq.2) iqf = 1
        if(iu.eq.4) iqf = 2
      mt = ptop(5)
      ves = 16.d0 * H0(iqf) + mt**2 * X0(iqf) - 4.d0*mt*B0(iqf)

       sq = 16.d0 * AH(iqf) + mt**2 * AX(iqf) - 4.d0*mt*AB(iqf)
      do j=1,4
       sp(j) = sq * 2.*pg(j) / mt / ves
      enddo

      call vortas(ptop, vh)
       do j = 1,3
        hv(j) = -(sp(4)*vh(j,4) - sp(1)*vh(j,1) - sp(2)*vh(j,2) 
     &                          - sp(3)*vh(j,3))
       enddo
*
      ves = ves * coef * mt**4 * rpar(16)
      return
      end
