*----------------------------------------------------------------------------*
*  author : Serge Slabospitsky   06.06.2006                                  *
*  FCNC_02 process: g   g   -> g    top                                      *
*     momenta:      p1  p2     p3   p4                                       *
*     spinors:                 DS3  DS4                                      * 
*  for T only, not for Tbar. However, IT = -6 is used for T-polar. evaluation*
* => iq1 should be POSITIVE                                                  *
*  averaged on initial spins and colors                                      *
*............................................................................*

      subroutine tfcnc_03(iq3, idia, p1, p2, p3, p4, ves, hvv)
      implicit none
      include "txpar.inc" 
      double precision p1(5), p2(5)       ! momenta of initial quarks
      double precision p3(5), p4(5)       ! momenta of Y and top 
      double precision Ves,coef, hvv(4),x3, 
     & s,s2,s3,s4,s5, t,t2, t3,t4,t5,ZZ, 
     & mt,mt2,mt3,mt4,mt6,mt7,mt8,mt9,mt10,mt12, mt14, 
     & y1, y2, sp(4), vh(3,4), aran,pyr,uu

      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      double complex U0(2), UP(2), AR, AL

      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer iq3,idia,iqf, j

*............................................................................*
      IF(first) THEN        ! initializing
        coef = rpar(10) ! transformation 1/GeV**2 to mb 
        coef = coef / 4.d0 ! due to lambda_a
        coef = coef * 8.d0 / 3.d0
*        coef = coef / (2.d0*2.d0 * 8.d0*3.d0) included 
        mt = mq(6)
        mt2 = mt**2
        mt3 = mt**3
        mt4 = mt**4
        mt6 = mt**6
        mt7 = mt**7
        mt8 = mt**8
        mt9 = mt**9
       mt10 = mt**10
       mt12 = mt**12
       mt14 = mt**14

        iqf = 11
       AR = mt*XR(iqf) - 4.d0*HR(iqf)
       AR = AR * conjg(AR)
       AL = mt*XL(iqf) - 4.d0*HL(iqf)
       AL = AL * conjg(AL)
        U0(1) = AR + AL
        UP(1) = AR - AL
*
        iqf = 12
       AR = mt*XR(iqf) - 4.d0*HR(iqf)
       AR = AR * conjg(AR)
       AL = mt*XL(iqf) - 4.d0*HL(iqf)
       AL = AL * conjg(AL)
        U0(2) = AR + AL
        UP(2) = AR - AL
 
       print*,'  Contributed code:   '
       print*,'  Rui Santos and Pedro Ferreira --> '
       print*,'  FCNC top-gluon-quark interaction '
       print*,'                     '

       first=.FALSE.
      ENDIF
      ves = 0.d0

        if(abs(iq3).eq.2) iqf = 1
        if(abs(iq3).eq.4) iqf = 2
*

       s = (p1(4) + p2(4))**2 - (p1(1) + p2(1))**2
     &   - (p1(2) + p2(2))**2 - (p1(3) + p2(3))**2
       t = (p1(4) - p4(4))**2 - (p1(1) - p4(1))**2
     &   - (p1(2) - p4(2))**2 - (p1(3) - p4(3))**2
 
       s2 = s**2
       s3 = s**3
       s4 = s**4
       s5 = s**5
       t2 = t**2
       t3 = t**3
       t4 = t**4
       t5 = t**5
       ZZ = (mt2-s)**2*s*(mt2-t)**2*t*(s+t-mt2)


       X3 = 4*(s+t)*mt14 - (8*s2 + 37*t*s + 8*t2)*mt12 
     & + 4*(s+t)*(2*s2 + 21*t*s + 2*t2)*mt10 
     & - 2*(4*s4 + 53*t*s3 + 109*t2*s2 + 53*t3*s + 4*t4)*mt8 
     & + 2*(s+t)*(2*s4 + 31*t*s3 + 86*t2*s2 + 31*t3*s + 2*t4)*mt6 
     & - s*t*(19*s4 + 122*t*s3 + 221*t2*s2 + 122*t3*s + 19*t4)*mt4 
     & + 6*s2*t2*(s+t)*(5*s2 + 9*t*s + 5*t2)*mt2 
     & - 3*s3*t3*(5*s2 + 4*t*s + 5*t2)
       X3 = X3 * U0(iqf)

      do J = 1,4
       y1 = p1(j)
       y2 = p2(j)
       sp(j) = (8.d0*mt2 - 15*s)*(mt2 -s)*(Y1 +Y2)*t5 
     & - ( 23*(Y1+Y2)*mt6 -s*(58*Y1 + 79*Y2)*mt4 
     &     +20*s2*(2*Y1+3*Y2)*mt2 + 3*s3*(Y1-4*Y2))*t4 
     & + ((29*Y1 + 36*Y2)*mt8 - 3*s*(21*Y1 + 46*Y2)*mt6 
     & + s2*(47*Y1 + 146*Y2)*mt4-75*s3*Y2*mt2 + 3*s4*(Y1+ 5*Y2))*t3 
     &- ((21*Y1+34*Y2)*mt10 -s*(35*Y1 + 132*Y2)*mt8 + 169*s2*Y2*mt6 
     &+ s3*(47*Y1-99*Y2)*mt4 + 20*s4*(Y2-2*Y1)*mt2 + 15*s5*Y1)*t2 
     & + mt2*(mt2-s)*((7*Y1+12*Y2)*mt8 + s*(7*Y1-43*Y2)*mt6 
     & + 2*s2*(27*Y2-14*Y1)*mt4 + 7*s3*(5*Y1-3*Y2)*mt2 - 23*s4*Y1)*t 
     & + mt4*(mt2-s)**2*(Y2*mt6 + 7.d0*s*(Y2 -Y1)*mt4+7*s2*Y1*mt2
     & -8.d0*s3*Y1)

      sp(j) = UP(iqf) * mt * sp(j) / x3 
      enddo

      call vortas(p4, vh)
       do j = 1,3
        hvv(j) = -(sp(4)*vh(j,4) - sp(1)*vh(j,1) - sp(2)*vh(j,2) 
     &                          - sp(3)*vh(j,3))
       enddo

      ves = X3 * coef * rpar(16)**2  / 48.d0 / ZZ

      UU = abs(mt2 - s)
      idia = 1
      aran = pyr(0)*(abs(t) + UU)
       if(aran.le.uu) then
        idia = 2
       else
        idia = 1
       endif


      if(iq3.gt.0) ves = -ves
*
      if(ves.le.0.d0) then
       print*,'NEGATIVE  ves x3 ',ves,x3
*      else 
*       print*,'positive  ves x3 ',ves,x3
      endif
      return
      end
