*----------------------------------------------------------------------------*
*  author : Serge Slabospitsky   07.06.2006                                  *
*  FCNC_04 process: g   q   -> gamma  top                                    *
*     momenta:      p1  p2     p3     p4                                     *
*     spinors:          DS2           DS4                                    * 
*  for T only, not for Tbar. However, IT = -6 is used for T-polar. evaluation*
* => iq1 should be POSITIVE                                                  *
*  averaged on initial spins and colors                                      *
*............................................................................*

      subroutine tfcnc_04(iq2, idia, p1, p2, p3, p4, ves, hr)
      implicit none
      include "txpar.inc" 
      double precision p1(5), p2(5)       ! momenta of initial gluon and quark 
      double precision p3(5), p4(5)       ! momenta of photon  and top 
      double precision x1(5), x2(5), km(5)  
      double precision Ves,coef,eg(5),ef(5),
     & hr(4), xt1, xt2,  pyr, aran
      integer iq2, iqf, i1,i2,i3,i4, idia, is1       ! top mother
      integer j5,j6,j7,j8
      double complex T1(2,2,2,2), T2(2,2,2,2), T3(2,2,2,2) 

      double complex veg(4,4), vef(4,4), 
     & PR1(4,4), PR2(4,4), DS2(2,4), DS4(2,4), 
     & VRT(4,4), UU1(4,4), UU2(4,4), UM1(4,4), UM2(4,4), U0,U1,U2
      LOGICAL first
      SAVE first, coef
      DATA first /.TRUE./
      double complex ei 
      data ei/(0.d0, 1.d0)/
*............................................................................*
      IF(first) THEN        ! initializing
        coef = rpar(10) ! transformation 1/GeV**2 to mb 
        coef = coef / (2.d0*2.d0 * 8.d0*3.d0) 
        coef = 4.d0 * coef * (Rpar(13)*2.d0/3.d0)**2
       first=.FALSE.
      ENDIF
      ves = 0.d0
       if(iq2.lt.0) return
        if(abs(iq2).eq.2) iqf = 1
        if(abs(iq2).eq.4) iqf = 2
*
      do j5 = 1,4
       do j6 = 1,4
        PR1(j5, j6) = (0.d0, 0.d0)
        PR2(j5, j6) = (0.d0, 0.d0)
       enddo
      enddo
*
      do 123 j5 = 1,2
      do 123 j6 = 1,2
      do 123 j7 = 1,2
      do 123 j8 = 1,2
       T1(j5,j6,j7,j8) = (0.d0, 0.d0)
       T2(j5,j6,j7,j8) = (0.d0, 0.d0)
 123   T3(j5,j6,j7,j8) = (0.d0, 0.d0)
        do i1 = 1,4
         x1(i1) = p2(i1) - p3(i1)
         x2(i1) = p1(i1) + p2(i1)
         km(i1) = -p3(i1) ! for vertex evaluation
        enddo
*
       call Dirs2_Ubar(p4, DS4) ! top 
       call Dirs2_V   (p2, DS2)
*
       x1(5) = p2(5)        !  up
        call Propf(x1, PR1)
       x2(5) = p4(5)        ! top
        call Propf(x2, PR2) ! top
      
       do 11 i1 = 1,2
        call VpolGAM(I1, is1, p1, eg)
        call phat(eg, Veg)
*
        call Q_GLU_T(iqf, p4, p1, eg, VRT)
        call prod_2(vrt, pr1, UU1)
*
        call Q_GLU_T(iqf, x2, p1, eg, VRT)
        call prod_2(PR2, vrt, UU2)
       do 11 i3 = 1,2
        call VpolGAM(I3, is1, p3, ef)
        call phat(ef, Vef)
         call prod_2(UU1, VeF, UM1)
         call prod_2(vef, UU2, UM2)
        call Q_GLU_GAM_T(iqf, p1, km, eg, ef, VRT)
       do 11 i2 = 1,2
       do 11 i4 = 1,2
        call Ubar_m_U(i4, i2, DS4, DS2, UM1, U0)
         T1(i1,i2,i3,i4) = T1(i1,i2,i3,i4) + U0
        call Ubar_m_U(i4, i2, DS4, DS2, UM2, U0)
         T2(i1,i2,i3,i4) = T2(i1,i2,i3,i4) + U0
        call Ubar_m_U(i4, i2, DS4, DS2, VRT, U0)
         T3(i1,i2,i3,i4) = T3(i1,i2,i3,i4) + U0
 11   continue
*
       ves = 0.d0
       xt1 = 0.d0
       xt2 = 0.d0
      do 12 i1 = 1,2
      do 12 i2 = 1,2
      do 12 i3 = 1,2
      do 12 i4 = 1,2
       U1 = T1(i1,i2,i3,i4)+T2(i1,i2,i3,i4)+T3(i1,i2,i3,i4)
       ves = ves + U1 * conjg(u1)
       xt1 = xt1 + T1(i1,i2,i3,i4)*conjg(T1(i1,i2,i3,i4))
       xt2 = xt2 + T2(i1,i2,i3,i4)*conjg(T2(i1,i2,i3,i4))
 12   continue
      aran = pyr(0)*(xt1+xt2) 
       idia = 1 
       if(aran.gt.xt1) idia = 2
* polarization
      do i1 = 1,4
       hr(i1) = 0.d0
      enddo
      do 14 i1 = 1,2
      do 14 i2 = 1,2
      do 14 i3 = 1,2
       U1 = T1(i1,i2,i3,1)+T2(i1,i2,i3,1)+T3(i1,i2,i3,1)
       U2 = T1(i1,i2,i3,2)+T2(i1,i2,i3,2)+T3(i1,i2,i3,2)
       hr(1) = hr(1) + (U1+U2) * conjg((U1+U2))
**
       hr(2) = hr(2) + (U1-ei*U2) * conjg((U1-ei*U2))
**
       hr(3) = hr(3) + 2.d0 * U1 * conjg(U1)
 14   continue
      do i1 = 1,3
       hr(i1) = (ves - hr(i1)) / ves
      enddo

* Top or TOPbar will be considered in top decay routines
      ves = ves * coef * rpar(16) 
      return
      end
