*----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 10.03.2002                                                              *
*   Top decays                                                               *
*----------------------------------------------------------------------------*
      subroutine THC_dec_INI 
*     --------------------                                                   *
* it is assumed, that FIRST/SECOND top is TOP(antiTOP)-quark                 *
* we consider the case of FACTORIZED  top quark decays                       *
* two probabilities WGT(1 : Top) and WGT(2 : Topbar) are returned            *
* three summed branching fractions BS(3) are considered                      *
* bs(1:3) = sum over all channels with MDT = 1,2,3                           *
*  W and H bosons branching fractions are included                           *
* FDT(...,1(2)) is KF code for first(UP) (second=Down) f f~ in top decay    *
*............................................................................*

      implicit None
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
*............................................................................*
      double precision Hgw !,    brtqw  ! additional BR
      common /HTdecp/  Hgw(2) !, brtqw(0:2) 
*
      double precision bX(3),  bW(3),  bH(3), bHS(3), bz(3) 
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IT = 1 : top quark,  IT = 2 : W-boson, 
*     IT = 3 : H+- boson,  IT = 4 : Z-boson 
*...........
      integer IT, I, J, j8
      double precision bht(5), bhx(5)
      double precision  widt0,widt1,delt, widh0,widh1,delh
      double precision  htb,thb, thbts 
      double precision  delh0, delt0 
      data delh0 / 0.05d0/, delt0 /0.05d0/

      double precision  twidnew   ! , wbwz
      character*4 ctl(-1:3)
      data ctl /'no  ','OFF ','T T~','T   ','  T~'/


      Character*32 INAMT(16)
      data INAMT /
     &' t -> d  W                      ',  !  1
     &' t -> s  W                      ',  !  2
     &' t -> b  W                      ',  !  3
     &' t -> b4 W  forbidden           ',  !  4
     &' H+-     : t -> b H+ (without t)',  !  5
     &' H+-     : t -> b H+ (H+ -> t* )',  !  6
     &' channel is not used            ',  !  7
     &' channel is not used            ',  !  8
     &' channel is not used            ',  !  9
     &' channel is not used            ',  ! 10
     &' FCNC    : t -> U gluon         ',  ! 11
     &' FCNC    : t -> C gluon         ',  ! 12
     &' FCNC    : t -> U gamma         ',  ! 13
     &' FCNC    : t -> C gamma         ',  ! 14
     &' FCNC    : t -> U Z             ',  ! 15
     &' FCNC    : t -> C Z             '/  ! 16
      character*4 chl(-1:3)
      data chl /'no  ','OFF ','H+H-','H+  ','H-  '/
      character*14 INAMH(20)
      data INAMH /
     &' U      Dbar  ', ' C      Dbar  ', ' T      Dbar  ', 
     &' t4     Dbar  ', ' U      Sbar  ', ' C      Sbar  ', 
     &' T      Sbar  ', ' t4     Sbar  ', ' U      Bbar  ', 
     &' C      Bbar  ', ' T*     Bbar  ', ' t4     Bbar  ', 
     &' U      b4bar ', ' C      b4bar ', ' T      b4bar ', 
     &' t4     b4bar ', 
     &' nu_e   e     ', ' nu_mu  mu    ', ' nu_tau tau   ', 
     &' nu_L   L     '/ 
*   H+- IDC 
*  1: U   Dbar   2: C    Dbar   3: T     Dbar   4: t4   Dbar  
*  5: U   Sbar   6: C    Sbar   7: T     Sbar   8: t4   Sbar 
*  9: U   Bbar  10: C    Bbar  11: T*    Bbar  12: t4   Bbar 
* 13: U  b4bar  14: C   b4bar  15: T    b4bar  16: t4   b4bar
* 17: NUe e     18: NUmu mu    19: NUtau tau   20: nuL4 L4

*.............. 
      integer itest
      TwidNew = 0.d0   ! decay width due to uncalculated channels
*............................................................................*
* 1 : d W,  2 : s W, 3 : b W                                                 *
* 5 : b H+, 6 : b H+ (-> t*)                                                 *
* 11:16 FCNC couplings, see FCNC_INI                                         *
* 11(12) = U(C) gluon,  13(14) = U(C) gamma,  15(16) = U(C) Z                *
*.................................
          
      widt0 = wid(0, 1)   ! top width = SM + FCNC 
      widh0 = wid(0, 3)   ! H+- width = all except top 
      if(mid(5, 1).eq.-1) goto 1112  ! no interactions with top
      itest = 0
       write(66,1445) rpar(51), rpar(55)
 1445  format('  M(H+-) ',e10.4,'  tan(beta) ',e10.4,/)
 1111  Rpar(36) = widt0 * mq(6)    ! M(top) * width(top total)
       rpar(54) = Rpar(51) * widh0 ! M(H+-) * width(H+- total)
           call HTB_dec(Htb)  ! H+ -> t b~ (normalized Gamma_t(total)
       itest = itest + 1
        widH1 = wid(0, 3) + htb
         wid(11, 3) = Htb
           call THB_dec(Rpar(54), Thb) 
           call THBTS_dec(rpar(54), rpar(36), Thbts) 
        widT1 = wid(0, 1) + Thb + Thbts
         wid(5, 1) = Thb     ! t -> b H+
         wid(6, 1) = Thbts   ! t -> b H+(->t*)
       delh = abs( (widh0 - widh1)/widh0) 
       delt = abs( (widt0 - widt1)/widt0)
       write(66,1444) itest, widH1, wid(0,3), htb, 
     & widT1, wid(0,1),thb,thbts 
 1444  format(2x,'Iter',1x,i5,' H(tot) H   Htb      ',3(e10.4,1x)
     & ,/, 12x,' T(tot) TSM Thb THT* ',4(e10.4,1x))
      if(delh.ge.delh0.or.delt.ge.delt0) then 
        widT0 = widT1
        widH0 = widH1
        goto 1111
      endif
         wid(0, 3) = widH1 
         wid(0, 1) = widT1 
 1112 continue
         rpar(53) = wid(0, 3) 
         rpar(54) = Rpar(51) * Rpar(53)  ! M(H+-) * width(H+- total)
*
      rpar(34) = wid(0, 1)
      Rpar(36) = mq(6) * rpar(34) ! M(top) * width(top total) 
*      
      it = 1   !  top
        do i = 1, mid(0, it)
         brf(I, it) = 0.d0
         if(MID(i, it).ne.-1) BRF(I, it) = wid(i,it) / wid(0,it) 
        enddo
* WARNING: we ignore FCNC top decay channels in H+- -> b t* decay
      it = 3   ! H+-
        do i = 1, mid(0, it)
         brf(I, it) = 0.d0
         if(MID(i, it).ne.-1) BRF(I, it) = wid(i,it) / wid(0,it) 
        enddo
         do j8 = 1,3
           bW(j8) = 0.d0
           bHX(j8) = 0.d0
           bHT(j8) = 0.d0
         enddo
      do 512 I = 1, mid(0, it)
        if (Mid(I, it).eq.0.OR.Mid(I, it).eq.-1) goto 512
          do 513 j = 1,3
           if(Mid(I, it).ne.j) goto 513
             if(I.eq.11) then
               bht(j) = bht(j) + brf(I, it)  ! H+- -> b T*
             else
               bhx(j) = bhx(j) + brf(I, it)  ! H+- -> f1 f2 
            endif 
 513      continue 
 512      continue 


      BRS(1,it) =  bhx(1) + bhx(2)              ! H+ -> ...
     &          + (bht(1) + bht(2)) * BRS(1,2)  !brtqw(1)  ! H+ -> top 
      BRS(2,it) =  bhx(1) + bhx(3)              ! H- -> ...
     &          + (bht(1) + bht(3)) * BRS(2,2)  !brtqw(2)  ! H- -> top 

      Hgw(1)    =  bhx(1) + bhx(2)              ! H+ -> f1 f2 
      Hgw(2)    =  bhx(1) + bhx(3)              ! H- -> f1 f2 
      if(BRF(11,3).le.0.9999999d0) then      ! correct for H+ -> T*
        Hgw(1) = Hgw(1) / (1.d0 - BRF(11,3)) ! correct for H+ -> T*
        Hgw(2) = Hgw(2) / (1.d0 - BRF(11,3)) ! correct for H+ -> T*
      endif

      j = -1
      do I = 1, mid(0, it)
       if(mid(I, it).ge.0) j = 0
      enddo
      if((j.eq.-1).OR.
     & (ipar(1).eq.5.or.ipar(1).eq.6.or.ipar(1).eq.7).OR.
     &((ipar(1).eq.1.or.ipar(1).eq.2.or.ipar(1).eq.3.or.
     &  ipar(1).eq.11.               or.ipar(1).eq.4.or.
     &  ipar(1).eq.20.or.
     &  ipar(1).eq.25.or.ipar(1).eq.25).AND.
     &  mid(5, 1).eq.-1)) then 
*       write(*, 74)  
 74    format(/,3x,'TopReX :  no H+- interaction',/,
     &          3x,'----------------------------') 
       goto 2567 

      endif
*       
      write(*, 75) Rpar(51), Rpar(55) ! , Rpar(35) 
 75   format(/,3x,'TopReX :  charged Higgs',/,
     &         3x,'-----------------------',/,
     &3x,'M(H+-) = ',f6.1,'  tan(beta) = ',f7.3,5x,/, 
     &3x,' channel',14x,'ON/OFF',2x,'width(GeV)',2x,'branching')

      do I = 1, mid(0, it)
       if(mid(I, it).ge.0) then 
        write(*, 76)  inamh(I),chl(mid(I,it)),wid(I,it),brf(I,it)
       endif
      enddo
 76   format(1p,3x,a14,10x,a4,1x,d10.3,2x,0p,e10.3) 
      write(*,77) wid(0,it) 
 77   format(3x,'total H+- width (GeV)   = ',3x,1p,e10.3)

      write(*,202) (BRS(i,it),i=1,2)
 202  format(/,'  TopReX : branching for H+- boson',
     &' including BR(W) from T*', /
     &,'  BR(H+ -> all) = ',0p,e10.3,6x,'  BR(H- -> all) = ',e10.3)

* for ID = 1:3       W-boson decay branching fractions are included
* for ID = 5:6       H-boson decay branching fractions are included
* for ID = 11:18     Z-boson decay branching fractions are included

************** TOP-QUARK **************************
 2567  continue
        do j8 = 1,3
         bW(j8) = 0.d0 
         bH(j8) = 0.d0 
         bHs(j8) = 0.d0 
         bZ(j8) = 0.d0 
         bX(j8) = 0.d0 
        enddo
      IT = 1    ! top quark
      do i = 1, mid(0, it) 
       if(MID(I, it).ne.0.AND.MID(I, it).ne.-1) then 
        do J = 1,3
         if(MID(I, it).eq.j) then
           if(i.eq.1.or.i.eq.2.or.i.eq.3)  then
              bw(j) = bw(j) + brf(I, it)   ! final state: W-boson 
           elseif(i.eq.5)        then
              bh(j) = bh(j) + brf(I, it)   ! final state: H+- -> f1f2
           elseif(i.eq.6)        then
              bhs(j) = bhs(j) + brf(I, it) ! final state: H+- -> b T*
           elseif(i.eq.15.or.i.eq.16.or.i.eq.17.or.i.eq.18) then
              bz(j) = bz(j) + brf(I, it)   ! t -> q Z via FCNC interactions
           else
              bX(j) = bX(j) + brf(I, it)   ! no W, H, or Z in the final state
           endif 
        endif
        enddo
       endif
      enddo


* in t -> b H+, H+ -> T* only allowes W-boson channels is considered
*  BRS(1,1)  single T
      BRS(1,IT) = (bW(1) + bW(2)) * BRS(1,2)          ! T -> W+
     &          + (bH(1) + bH(2)) * Hgw(1)            ! T -> H+ ->f1 f2
     &          + (bhs(1)+ bhs(2))* BRS(1,2)          ! T -> b H+ -> b T*
     &          + (bZ(1) + bz(2)) * BRS(1,4)          ! T -> Z 
     &          +  bX(1) + bX(2)                      ! T -> X+ 
*  BRS(2,1)  single T~
      BRS(2,IT) = (bW(1) + bW(3)) * BRS(2,2)          ! T~ -> W-
     &          + (bH(1) + bH(3)) * Hgw(2)            ! T~ ->H- ->f1 f2
     &          + (bhs(1)+ bhs(3))* BRS(2,2)          ! T~ -> b H- -> b T*
     &          + (bZ(1) + bz(3)) * BRS(1,4)          ! T~ -> Z 
     &          +  bX(1) + bX(3)                      ! T~ -> X-

      write(*, 71) mq(6)
 71   format(/,'   TopReX : top decays ',/
     &,        '   --------------------',/
     &,        '   m(top) = ',f7.2,' GeV',/,
     &3x,' channel',26x,'ON/OFF',2x,'width(GeV)',2x,'Branching')


      do I = 1, mid(0, it)
       if(mid(I, it).ge.0) then 
        write(*, 78)  inamt(I),ctl(mid(I,it)),wid(I,it),brf(I,it)
       endif
      enddo
 78   format(1p,3x,a32,3x,a4,2x,e10.3,2x,0p,e10.3) 
      write(*,79) rpar(34)
 79   format(3x,'total top width (GeV)',17x,'=',2x,1p,e10.3)

      WRITE(*,603) (BRS(i,1),i=1,2)
 603  format('  branching ratios for top and top_bar quarks ',/
     &,'  BR(T -> all) = ',1p,e10.3,6x,'BR(Tbar -> all) = ',1p,e10.3,
     &//)
      return
      end
