c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   22.05.2006                                 *
*....
      subroutine Top_dec_qZ(id, iq, il1, p, k, l1, l2, ves, hh) 
*     --------------------------------------------                           *
* FCNC top quark decay into u(c)-quark and Z (-> f fbar)                     *
*                                                                            *
*  Z-boson denominator excluded                                              *
*............................................................................*

      implicit none
      include "txpar.inc" 
*...........
      double precision p(5), k(5), l1(5), l2(5)
      double precision Ves, coef, scalp
      LOGICAL first
      SAVE first, COEF 
      DATA first /.TRUE./
      integer id, Iq, il1
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff
      double precision F0(2),H0(2),U0(2), AF(2), AH(2), W0(2),
     &  AA, AB, mt, mt2, pk
      double precision hh(5), q(5), kl1,kl2,pl1,pl2,qk,t1,t2,
     & q2, zn1
      integer j, j4, idd
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
* 
      if(first) THEN
       coef = Rpar(27)**2 * pi2_4 / 2.d0 / 2.d0
*       coef = pi2_4 / 2.d0 / 2.d0
*..Rpar(27)     : g_z         = e / sin(2*theta_W) 
       do J = 1, 2
        j4 = J + 14
        F0(j) = FL(j4)*conjg(FL(j4)) + FR(j4)*conjg(FR(j4))
        AF(j) = FL(j4)*conjg(FL(j4)) - FR(j4)*conjg(FR(j4))
        H0(j) = HL(j4)*conjg(HL(j4)) + HR(j4)*conjg(HR(j4))
        AH(j) = HL(j4)*conjg(HL(j4)) - HR(j4)*conjg(HR(j4))
        U0(j) = FL(j4)*conjg(HL(j4)) + conjg(FL(j4))*HL(j4)
     &        + FR(j4)*conjg(HR(j4)) + conjg(FR(j4))*HR(j4)
        W0(j) = FL(j4)*conjg(HL(j4)) + conjg(FL(j4))*HL(j4)
     &        - FR(j4)*conjg(HR(j4)) - conjg(FR(j4))*HR(j4)
       enddo
      first = .false. 
      ENDIF

      idd = id - 14
      AA = zff(1,il1)**2 + zff(2,il1)**2
      AB = zff(1,il1) * zff(2,il1) 

      pl1 = scalp(p, l1)        
      pl2 = scalp(p, l2)        
      kl1 = scalp(k, l1)        
      kl2 = scalp(k, l2)        
       do J = 1, 4
        q(j) = l1(j) + l2(j)
       enddo
      q2 = q(4)**2 - q(1)**2 - q(2)**2 - q(3)**2 
      zn1 = (q2 - Rpar(46))**2 + rpar(48)**2

       q(5) = dsqrt(q2)
*
      qk  = scalp(k, q)        
      pk  = scalp(k, p)        
      mt  = p(5)
      mt2 = p(5)**2

      t1 =  F0(idd)     *(pl1*kl2 + pl2*kl1)
     & + 4.d0*q2*H0(idd)*(pl1*kl1 + pl2*kl2)
     & - mt * q2 * qk * U0(idd)

      t2 = AF(idd)   *(pl1*kl2 - pl2*kl1)
     & - 4.d0*q2*AF(idd)*(pl1*kl1 - pl2*kl2)
     & + 2.d0*mt*q2*W0(idd)*(kl1-kl2)

      ves = 16.d0*AA*t1 + 32.d0*AB*t2

      hh(5) = 0.d0
      do j = 1,4
      t1 = -mt*AF(idd)*  (kl2*l1(j) + kl1*l2(j))
     & + 4.d0*q2*AH(idd)*(kl1*l1(j) + kl2*l2(j))
     & - 2.d0*W0(idd)*(pl1*pl2-pl2**2+2.d0*mt*kl2)*l1(j)
     & - 2.d0*W0(idd)*(pl1*pl2-pl1**2+2.d0*mt*kl1)*l2(j)

      t2 = mt*F0(idd)*      (kl1*l2(j) - kl2*l1(j))
     & + 4.d8*mt*q2*H0(idd)*(kl1*l2(j) - kl1*l1(j))
     & + 4.d0*W0(idd)*pk*(pl2*l1(j) - pl1*l2(j))
        hh(j) = (16.d0*AA*t1 + 32.d0*AB*t2) / ves
        hh(j) = -hh(j) ! transit to 3-space 
      enddo

      ves = ves * coef / mt / zn1
      if(abs(il1).le.5) ves = ves * 3.d0
      RETURN
      end
