c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   06.09.2002                                 *
*....                                                                        *
       subroutine top_rdec_2(id1, id2, kp1, kp2) 
*     --------------------------------------------------                     *
*  ID1 and ID2 are numbers of first and second top-quark decay channels      *
*  KP1 and KP2 are the positions of t-quarks in KUP list                     *
*  KFT1 and KFT2 are the KF codes  of t1 and t2 quarks                       *
*............................................................................*

      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/  pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer I, J, igq, irs1, irs2, id1, id2, KP1, kp2, kft1, kft2 
      double precision mt1, mt2 
      double precision vh 
      common /topol2/  vh(2,3,3)
      double precision pyr, ves
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRES = 1 : top quark,  IRES = 2 : W-boson, 
*     IRES = 3 : H+- boson,  IRES = 4 : Z-boson 
*     IRS = 5 : t -> b H* -> T* 
      integer ndec1, kdec1(20,3), ndec2, kdec2(20,3)
      double precision pdm1(20,5),  pdm2(20,5)
      double precision cos3, nv(3), nv1(3), nv2(3)
      common /nvv/nv
*...
* start executing !
      irs1 = -1
      irs2 = -1
*
       kft1 = idup(kp1)  ! top KF code
       kft2 = idup(kp2)  ! top KF code

                           igq = 2   !  q qbar -> T Tbar
        if(idup(1).eq.21)  igq = 1   !  G G    -> T Tbar
*
      if( id1.eq.1.OR.id1.eq.2
     &.OR.id1.eq.3)               irs1 = 2 ! W-boson
      if( id1.eq.5)               irs1 = 3 ! H-boson
      if( id1.eq.6)               irs1 = 5 ! t -> H -> t* 
      if (id1.eq.11.or.id1.eq.12
     &.or.id1.eq.13.or.id1.eq.14) irs1 = 1 ! t -> q G (A) 
      if( id1.eq.15.or.id1.eq.16
     &.or.id1.eq.17.or.id1.eq.18) irs1 = 4 ! t -> q Z 
      if(irs1.eq.-1) STOP
*
* second top quark
      if( id2.eq.1.OR.id2.eq.2
     &.OR.id2.eq.3)               irs2 = 2 ! W-boson
      if( id2.eq.5)               irs2 = 3 ! H-boson
      if( id2.eq.6)               irs2 = 5 ! t -> H+- -> t*
      if (id2.eq.11.or.id2.eq.12
     &.or.id2.eq.13.or.id2.eq.14) irs2 = 1 ! t -> q G (A) 
      if( id2.eq.15.or.id2.eq.16
     &.or.id2.eq.17.or.id2.eq.18) irs2 = 4 ! t -> q Z 
      if(irs2.eq.-1) STOP
* 
*  top decay procedure
*
      nv1(1) = 0.d0
      nv1(2) = 0.d0
      nv1(3) = 0.d0
       cos3 = 
     & dsqrt(pup(1,kp1)**2+pup(2,kp1)**2+pup(3,kp1)**2)
       if(cos3.ge.0.001d0) then
        nv1(1) = pup(1,kp1) / cos3
        nv1(2) = pup(2,kp1) / cos3
        nv1(3) = pup(3,kp1) / cos3
       endif 

      nv2(1) = 0.d0
      nv2(2) = 0.d0
      nv2(3) = 0.d0
       cos3 = 
     & dsqrt(pup(1,kp2)**2+pup(2,kp2)**2+pup(3,kp2)**2)
       if(cos3.ge.0.001d0) then
        nv2(1) = pup(1,kp2) / cos3
        nv2(2) = pup(2,kp2) / cos3
        nv2(3) = pup(3,kp2) / cos3
       endif 


 11   continue

       nv(1) = nv1(1)
       nv(2) = nv1(2)
       nv(3) = nv1(3)
      mt1 = pup(5,kp1)
       if(irs1.eq.1) call Top_dec_01(id1, kft1, MT1) 
       if(irs1.eq.2) call Top_dec_02(id1, kft1, MT1) 
       if(irs1.eq.3) call Top_dec_03(kft1, MT1)
       if(irs1.eq.4) call Top_dec_04(id1, kft1, MT1)
       if(irs1.eq.5) call Top_dec_05(kft1, mt1)

       ndec1 = ndec
       do I = 1,20
         kdec1(I,1) = kdec(I,1) 
         kdec1(I,2) = kdec(I,2) 
         kdec1(I,3) = kdec(I,3) 
           do J = 1,5
            pdm1(I, J) = pdm(I, J) 
           enddo
       enddo

*
       nv(1) = nv2(1)
       nv(2) = nv2(2)
       nv(3) = nv2(3)
      mt2 = pup(5,kp2)
       if(irs2.eq.1) call Top_dec_01(id2, kft2, MT2) 
       if(irs2.eq.2) call Top_dec_02(id2, kft2, MT2)
       if(irs2.eq.3) call Top_dec_03(kft2, MT2)
       if(irs2.eq.4) call Top_dec_04(id2, kft2, MT2)
       if(irs2.eq.5) call Top_dec_05(kft2, mt2)
*
       ndec2 = ndec
       do I = 1,20
         kdec2(I,1) = kdec(I,1) 
         kdec2(I,2) = kdec(I,2) 
         kdec2(I,3) = kdec(I,3) 
           do J = 1,5
            pdm2(I, J) = pdm(I, J) 
           enddo
       enddo
* 
      IF(ipar(33).eq.1) THEN ! take into account spin of produced tops
       ves = 0.d0
        do i = 1,3
         do j = 1,3
           ves = ves + vh(igq, i, j) * pdm1(20,i) * pdm2(20,j)
         enddo
        enddo
       ves = (1.d0 + ves) / 4.d0
      if(pyr(0).ge.ves) goto 11
      ENDIF
* FIRST  top :  feel final f1 f2~ KF codes and color flow information
       ndec = ndec1
       do I = 1,20
         kdec(I,1) = kdec1(I,1) 
         kdec(I,2) = kdec1(I,2) 
        do J = 1,5
         pdm(I, J) = pdm1(I, J) 
        enddo
       enddo

      if(irs1.eq.1)                               then
        call colorf_t_qv (kp1) 
      elseif(irs1.eq.2.or.irs1.eq.3.or.irs1.eq.4) then
        call colorf_t_q2f(kp1) 
      elseif(irs1.eq.5)                           then
        call colorf_t_qht(kp1) 
      endif

* SECOND top    
       ndec = ndec2
       do I = 1,20
         kdec(I,1) = kdec2(I,1) 
         kdec(I,2) = kdec2(I,2) 
        do J = 1,5
         pdm(I, J) = pdm2(I, J) 
        enddo
       enddo
      if(irs2.eq.1)                               then
         call colorf_t_qv(kp2) 
      elseif(irs2.eq.2.or.irs2.eq.3.or.irs2.eq.4) then
        call colorf_t_q2f(kp2) 
      elseif(irs2.eq.5)                           then
        call colorf_t_qht(kp2) 
      endif

      RETURN 
      end
