*----------------------------------------------------------------------------*
* author : Serge Slabospitsky  08.06.2006                                    *
* normal run
*............................................................................*
      subroutine TX_GEN
      implicit none
      include "hepeup.inc"
      include "txpar.inc" 
      include "txpro.inc" 
*...Standard PYTHIA 6.2 event data common.
      include "pydat_62.inc"
C...User process event common block 
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      double precision EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
* PYTHIA6.2 common block for external user's process 
      double precision sigpb, xcspb(-6:6,-6:6)
      common/xsecpb/   sigpb, xcspb
      double precision xst, wrk
* rxsig(I,1) : sum of differential X-section   
* rxsig(I,2) : total X-section value
* rxsig(I,3) : max of differential X-section 
* rxsig(I,4) : sum of differential X-section squared
      integer ip1, ip2
      integer I, J, jk1,jk2   
      double precision PYR, ARAN 
*      double precision mbpb
*      data mbpb /1.d09/
      double precision nsng1, nsng2
      common /xmatch/nsng1(2), nsng2(2)
*
      double precision Pus        ! 4-momenta of user's particles
      common /user_mom/ Pus(20,5)
      integer Icur, Nups
*........................................      

      Ipar(100) = IDPRUP 
      Ipar(1) = Ipar(100)
      Icur = Ipar(1)
      Ipar(8) = 1     ! running 
 998  continue
      NXev(ipar(1)) = NXev(ipar(1)) + 1
       call TX_GEJZER(NUPS)   
      if(sigpb.le.0.d0) goto 998

* two options for SIGPB and SIGMX
* sigPB < sigMX or sigPB = sigMX : sigPB is added to Xsig, then compared sigMX
* sigPB > sigMX 
* Ipar(17) =  0: normal case, event is always (!) accepted, sigPB => + Xsig
* Ipar(17) = +1: if sigPB > sigMX events is NOT accepted 
*                and  sigPB is NOT added to Xsig

      if(txsel.eq.1.or.txsel.eq.2) goto 901 
      If(sigpb.le.RXsig(icur,3) ) then
          RXsig(icur,1) = RXsig(icur,1) + sigpb        
          RXsig(icur,2) = RXsig(icur,1) / NXev(icur)
          aran  = pyr(0) * RXsig(icur,3) ! sigmx 
          if(sigpb.lt.aran) goto 998
      ElseIf(sigpb.gt.RXsig(icur,3) ) then
        if(Ipar(17).eq.0) then
          RXsig(icur,1) = RXsig(icur,1) + sigpb        
          RXsig(icur,2) = RXsig(icur,1) / NXev(icur)
          RXsig(icur,3) = sigpb
        elseif(Ipar(17).eq.1) then
          goto 998    ! event is not accepted
        else
          print*,' Ipar(17) = ',Ipar(17),' not allowed. stop' 
          STOP
        endIf
      EndIf
 901  continue
* TopReX matching 
       If(txsel.eq.1.or.txsel.eq.2) then 
          RXsig(Ipar(100),1) = RXsig(Ipar(100),1) + sigpb
          RXsig(ipar(100),2) = RXsig(Ipar(100),1) / NXev(ipar(100)) 
        if(sigpb.gt.RXsig(Ipar(100),3)) RXsig(Ipar(100),3) = sigpb
          aran  = pyr(0) * RXsig(Ipar(100),3) 
          if(sigpb.lt.aran) goto 998
       endif 
 996  xst=sigpb * PYR(0) 
      do i=-5,5
        do j=-5,5
          wrk=xcspb(i,j)
          if(wrk.gt.0.d0)then
            if(xst.lt.wrk)then
              ip1=i             ! parton type from hadron_1
              ip2=j             ! parton type from hadron_2 
              goto 601
            else
              xst=xst - wrk 
            endif
          endif
        enddo
      enddo
      goto 998                  ! bad rndm for initial process
 601  continue
*     
       xwgtup = RXsig(ipar(100), 2)
       Rpar(64) = RXsig(ipar(100), 2) 
* TopReX matching
      IF(txsel.eq.1.or.txsel.eq.2) THEN
       xwgtup = rpar(18) * RXsig(ipar(100),1) / NXev(ipar(100)) 
       if(txsel.eq.1) then
         Rpar(64) =
     &   (RXsig(1,1)/NXev(1)) * nsng1(1) / (nsng1(1) + nsng1(2))
     & + (Rxsig(2,1)/NXev(2)) * nsng2(2) / (nsng2(1) + nsng2(2))
       elseif(txsel.eq.2) then
         Rpar(64) =
     &   (RXsig(30,1)/NXev(30)) * nsng1(1) / (nsng1(1) + nsng1(2))
     & + ( Rxsig(31,1)/NXev(31) + Rxsig(32,1)/NXev(32) 
     & +   Rxsig(33,1)/NXev(33))* nsng2(2)/(nsng2(1) + nsng2(2))
       endif
      ENDIF 


      scalup = rpar(3)
      NUP  = nups 
       do jk1 = 1,maxnup
        idup(jk1) = 0
        istup(jk1) = 0
        mothup(1,jk1) = 0
        mothup(2,jk1) = 0
        icolup(1,jk1) = 0
        icolup(2,jk1) = 0
         do jk2 = 1,5
          pup(jk2, jk1) = 0.d0
         enddo
       enddo

* fill momenta for PYTHIA
      do j = 1, NUP
        do i=1,5
          pup(i,j) = pus(j,i)
        enddo
      enddo

         AQEDUP = rpar(11) 
         AQCDUP = rpar(15)
*  common settings for hard process: parton_1 + parton_2  
        istup(1) = -1     ! first parton 
        mothup(1,1)=0    
        mothup(2,1)=0    
        idup(1) = ip1
         istup(2) = -1    ! second parton
         mothup(1,2)=0   
         mothup(2,2)=0
         idup(2)=ip2
      
*
      if    (Ipar(1).eq.1)  then
        call ColorF_01(ip1,ip2)      !  W-gluon process
      elseif(Ipar(1).eq.2)  then
        call ColorF_02(ip1, ip2)     !  W-gluon process   2 -> 3
      elseif(Ipar(1).eq.3)  then
        call ColorF_03(ip1, ip2)     !  t W  process
      elseif(Ipar(1).eq.4.or.Ipar(1).eq.8.        ! (W* H*) -> T Bbar 
     &    or.Ipar(1).eq.6.or.Ipar(1).eq.9) then   ! (W* + H*) -> tau nu
        call ColorF_04(ip1, ip2)    
      elseif(Ipar(1).eq.20) then
        call ColorF_20(ip1, ip2)     !  t t~    process (SM)
      elseif(Ipar(1).eq.5) then 
        call ColorF_05(ip1, ip2)     !  WQQbar  process
      elseif(Ipar(1).eq.23)   then 
        call ColorF_23(ip1,ip2)      !  Z Q Qbar
      elseif(Ipar(1).eq.24)   then 
        call ColorF_24(ip1,ip2)      !   g g -> Z Z    with   Z -> f fbar 
      elseif(Ipar(1).eq.25)   then 
        call ColorF_25(ip1,ip2)      !  t tbar gamma 
      elseif(Ipar(1).eq.7.or.Ipar(1).eq.10) then 
        call ColorF_07(ip1,ip2)      !  JET + (W* H*) 
      elseif(Ipar(1).eq.61)   then 
        call ColorF_61(ip1,ip2)      !  H+ H- 
      elseif(Ipar(1).eq.29)  then
        call ColorF_29(ip1,ip2)      !  FCNC -> t
      elseif(Ipar(1).eq.30)  then
        call ColorF_30(ip1,ip2)      !  FCNC -> t
      elseif(Ipar(1).eq.31)  then
        call ColorF_31(ip1,ip2)      !  FCNC -> T q
      elseif(Ipar(1).eq.32)  then
        call ColorF_32(ip1,ip2)      !  FCNC -> T q
      elseif(Ipar(1).eq.33)  then
        call ColorF_33(ip1,ip2)      !  FCNC -> T g
      elseif(Ipar(1).eq.34)  then
        call ColorF_34(ip1,ip2)      !  FCNC -> T g
*
      else 
         write(*,4114) Ipar(1)
 4114    format(3x,'TopReX : HEPEUP',/,
     &          3x,'---------------',/,
     &          3x,'TopReX can not run process ',i4,'  with PYTHIA',/
     &          3x,'stop TopReX run')
        STOP
      ENDIF
 8888 continue
      if(ipar(12).eq.1) call TX_HRD_OUT 
      RETURN
      END
