*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky                                             *
*... 31.01.2005                                                              *
* this routine evaluates Q-scales for PDF (Rpar(3)) and alpha_S (Rpar(4)**2) *
*..Ipar(3, 4) is the evolution scale type for PDF (alpha_S)                  *
*  if ipar(4) = 0, then Q^2(PDF) ==> Q^2(alphas)                             *
*  ipar(3,4) < 0 corresponds to user's input                                 *
*..Rpar(3)      : Evolution scale for PDF                                    *
*..Rpar(4)      : Evolution scale for alpha_s                                *
*
      subroutine TXQscale
*     -------------------                                                    *
* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
      implicit None
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision PYalps, Q22 
      logical first
      data first /.TRUE./
      save first
      CHARACTER*25 np          ! process's name 
      COMMON /NAMPROCESS/np(200)
      character*30 namQpdf(200,10), namQalf(200,10)
      integer iprc, ipr4
      double precision sqq, alps, alpsZ
      common /testpdf/ sqq, alps 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*
      IF(first) THEN
      if(Ipar(1).eq.1.or.Ipar(1).eq.2.or.Ipar(1).eq.11) Iprc = 1
      if(Ipar(1).eq.3)                                  Iprc = 3
      if(Ipar(1).eq.4)                                  Iprc = 4
      if(Ipar(1).eq.20)                                 Iprc = 20
      if(Ipar(1).eq.5)                                  Iprc = 5 
      if(Ipar(1).eq.6.or.Ipar(1).eq.9)                  Iprc = 6
      if(Ipar(1).eq.7.or.Ipar(1).eq.10)                 Iprc = 7
      if(Ipar(1).eq.8)                                  Iprc = 8 
      if( Ipar(1).eq.30.or.Ipar(1).eq.31.
     & or.Ipar(1).eq.32.or.Ipar(1).eq.33.
     & or.Ipar(1).eq.34)                               Iprc = 30
      if(Ipar(1).eq.23)                                 Iprc = 23
      if(Ipar(1).eq.24)                                 Iprc = 24
      if(Ipar(1).eq.25)                                 Iprc = 25
      if(Ipar(1).eq.61)                                 Iprc = 61
      if(Ipar(1).eq.99)                                 Iprc = 1

*  Ipar(1) = 1, 2, 11   single top production
       namQpdf(1,1) = 'm(top)/sqrt(2)                '     
       namQpdf(1,2) = 'm(top)                        '
       namQpdf(1,3) = 'm(W)                          '
       namQalf(1,1) = 'm(top)/sqrt(2)                '
       namQalf(1,2) = 'm(top)                        '
       namQalf(1,3) = 'm(W)                          '
*  Ipar(1) = 3          single top production
       namQpdf(3,1) = 'm(top)/sqrt(2)                '
       namQpdf(3,2) = 'm(top)                        '
       namQpdf(3,3) = 'm(W)                          '
       namQalf(3,1) = 'm(top)/sqrt(2)                '
       namQalf(3,2) = 'm(top)                        '
       namQalf(3,3) = 'm(W)                          '
*  Ipar(1) = 4          single top production
       namQpdf(4,1) = 'm(top)/sqrt(2)                '
       namQpdf(4,2) = 'm(top)                        '
       namQpdf(4,3) = 'm(W)                          '
       namQpdf(4,4) = 'sqrt(Shat)                    '
       namQalf(4,1) = 'm(top)/sqrt(2)                '
       namQalf(4,2) = 'm(top)                        '
       namQalf(4,3) = 'm(W)                          '
       namQalf(4,4) = 'sqrt(Shat)                    '
*  Ipar(1) = 20, 21, 22  t tbar    production
       namQpdf(20,1) = 'sqrt(m(top)**2 + PT(top)**2)  '
       namQpdf(20,2) = 'm(top)/sqrt(2)                '
       namQpdf(20,3) = 'm(top)                        '
       namQalf(20,1) = 'sqrt(m(top)**2 + PT(top)**2)  '
       namQalf(20,2) = 'm(top)/sqrt(2)                '
       namQalf(20,3) = 'm(top)                        '
*  Ipar(1) = 25  (t tbar gamma)   production
       namQpdf(25,1) = 'm(top)/sqrt(2)                '
       namQpdf(25,2) = 'm(top)                        '
       namQalf(25,1) = 'm(top)/sqrt(2)                '
       namQalf(25,2) = 'm(top)                        '
*  Ipar(1) = 5      W Q Qbar       production
       namQpdf(5,1) = 'M(W)                          '   
       namQpdf(5,2) = 'sqrt(m(W)**2 + PT(W)**2)      '
       namQalf(5,1) = 'M(W)                          '
       namQalf(5,2) = 'sqrt(m(W)**2 + PT(W)**2)      '
*  Ipar(1) = 23      Z Q Qbar       production
       namQpdf(23,1) = 'M(Z)                          '
       namQpdf(23,2) = 'sqrt(m(Z)**2 + PT(Z)**2)      '
       namQalf(23,1) = 'M(Z)                          '
       namQalf(23,2) = 'sqrt(m(Z)**2 + PT(Z)**2)      '
*  Ipar(1) = 24      Z Q Qbar       production
       namQpdf(24,1) = 'M(Z)                          '
       namQpdf(24,2) = 'sqrt(m(Z)**2 + PT(Z)**2)      '
       namQalf(24,1) = 'M(Z)                          '
       namQalf(24,2) = 'sqrt(m(Z)**2 + PT(Z)**2)      '
*  Ipar(1) = 6      q q~' -> W+- + H+-  -> tau nu 
       namQpdf(6,1) = 'Shat                          '
       namQalf(6,1) = 'Shat                          '
*  Ipar(1) = 7      q q~' -> H+- JET  -> tau nu 
       namQpdf(7,1) = 'mass(W* or H*)                '
       namQalf(7,1) = 'mass(W* or H*)                '
*  Ipar(1) = 8         H* -> t bbar 
       namQpdf(8,1) = 'm(top)/sqrt(2)                '
       namQpdf(8,2) = 'm(top)                        '
       namQpdf(8,3) = 'm(H+-)                        '
       namQpdf(8,4) = 'sqrt(Shat)                    '
       namQalf(8,1) = 'm(top)/sqrt(2)                '
       namQalf(8,2) = 'm(top)                        '
       namQalf(8,3) = 'm(H+-)                        '
       namQalf(8,4) = 'sqrt(Shat)                    '
*  Ipar(1) = 30        FCNC g U -> t 
       namQpdf(30,1) = 'm(top)                        '
       namQpdf(30,2) = 'sqrt(Shat)                    '
       namQalf(30,1) = 'm(top)                        '
       namQalf(30,2) = 'sqrt(Shat)                    '
*  Ipar(1) = 31 or Ipar(1) = 32   FCNC: q q -> T q
       namQpdf(31,1) = 'sqrt(m(top)**2 + PT(top)**2)  '
       namQpdf(31,2) = 'm(top)/sqrt(2)                '
       namQpdf(31,3) = 'm(top)                        '
       namQalf(31,1) = 'sqrt(m(top)**2 + PT(top)**2)  '
       namQalf(31,2) = 'm(top)/sqrt(2)                '
       namQalf(31,3) = 'm(top)                        '
*  Ipar(1) = 61, 62    H+ H-  production
       namQpdf(61,1) = 'm(H+-)                        '
       namQalf(61,1) = 'm(H+-)                        '
*
      ENDIF 
**

      if(Ipar(1).eq.1.or.Ipar(1).eq.2.or.Ipar(1).eq.11) goto 1 
      if(Ipar(1).eq.3)                                  goto 3 
      if(Ipar(1).eq.4)                                  goto 4 
      if(Ipar(1).eq.20)                                 goto 20
      if(Ipar(1).eq.5)                                  goto 5 
      if(Ipar(1).eq.6.or.Ipar(1).eq.9)                  goto 6
      if(Ipar(1).eq.7.or.Ipar(1).eq.10)                 goto 7
      if(Ipar(1).eq.8)                                  goto 8 
      if(Ipar(1).eq.30.or.Ipar(1).eq.31.
     &or.Ipar(1).eq.32.or.Ipar(1).eq.33.
     &or.Ipar(1).eq.34)                                 goto 30
      if(Ipar(1).eq.23)                                 goto 23
      if(Ipar(1).eq.24)                                 goto 24
      if(Ipar(1).eq.25)                                 goto 25
      if(Ipar(1).eq.61)                                 goto 61
      if(Ipar(1).eq.99)                                 goto 1 
      return
*...
 1    continue !  t-channel top production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6)                   ! PDF: m_t
       elseif(Ipar(3).eq.3) then
         Rpar(3) = Rpar(41)                ! PDF: M(W) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                 ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6) / dsqrt(2.d0)     ! alpha_s: m(top)/ sqrt(2)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6)                   ! alpha_s: m(top)
       elseif(Ipar(4).eq.3) then
         Rpar(4) = Rpar(41)                ! alpha_s: M(W) 
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      goto 5555
***
 3    continue !  tW-channel single top production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6)                   ! PDF: m_t
       elseif(Ipar(3).eq.3) then
         Rpar(3) = Rpar(41)                ! PDF: M(W) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                 ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6) / dsqrt(2.d0)     ! alpha_s: m(top) / sqrt(2) 
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6)                   ! alpha_s: m(top)
       elseif(Ipar(4).eq.3) then
         Rpar(4) = Rpar(41)                ! alpha_s: M(W) 
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      goto 5555
***
 4    continue !  s-channel single top production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6)                   ! PDF: m_t
       elseif(Ipar(3).eq.3) then
         Rpar(3) = Rpar(41)                ! PDF: M(W) 
       elseif(Ipar(3).eq.4) then
         Rpar(3) = Rpar(74)               ! PDF: sqrt(Shat) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6) / dsqrt(2.d0) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)   
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                 !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6) / dsqrt(2.d0)     ! alpha_s: m(top) / sqrt(2)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6)                   ! alpha_s: m(top)           
       elseif(Ipar(4).eq.3) then
         Rpar(4) = Rpar(41)                ! alpha_s: M(W)
       elseif(Ipar(4).eq.4) then
         Rpar(4) = Rpar(74)               ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      GOTO 5555
***
 20   continue !  t tbar production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> PDF
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6) / dsqrt(2.d0)       ! PDF: m(top) / sqrt(2)
       elseif(Ipar(3).eq.3) then
         Rpar(3) = mq(6)                     ! PDF: m_t
       else
         Ipar(3) = 1                         ! return to default version
         Rpar(3) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> PDF
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                   !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> alpha_s
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6) / dsqrt(2.d0)       ! PDF: m(top) / sqrt(2)
       elseif(Ipar(4).eq.3) then
         Rpar(4) = mq(6)                    ! alpha_s: m(top)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***
 5    continue !  W Q Qbar production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(41)               ! PDF: M(W) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) =  dsqrt(Rpar(42) + Rpar(76))  ! PDF: sqrt(M(W)^2 + PT(W)^2)
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = Rpar(41) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                       ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(41)                      ! alpha_s: M(W)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = dsqrt(Rpar(42) + Rpar(76))   ! M(W)^2 + PT(W)^2
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      GOTO 5555
***
 23    continue !  Z Q Qbar production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(45)               ! PDF: M(Z) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) =  dsqrt(Rpar(46) + Rpar(76)) ! PDF: sqrt(M_Z^2 + PT(Z)^2)
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = Rpar(45) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                       ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(45)                      ! alpha_s: M(Z)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = dsqrt(Rpar(46) + Rpar(76))   ! M(Z)^2 + PT(Z)^2
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      GOTO 5555
***
 24    continue !  g g -> Z Z production 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(45)               ! PDF: M(Z) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) =  dsqrt(Rpar(46) + Rpar(76)) ! PDF: sqrt(M_Z^2 + PT(Z)^2)
       elseif(Ipar(3).eq.3) then
         Rpar(3) =  Rpar(74)    ! PDF: sqrt(Shat)
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = Rpar(45) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                       ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(45)                      ! alpha_s: M(Z)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = dsqrt(Rpar(46) + Rpar(76))   ! M(Z)^2 + PT(Z)^2
       elseif(Ipar(4).eq.3) then
         Rpar(4) =  Rpar(74)                    ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      GOTO 5555
***
 25    continue !  q qbar -> t tbar gamma roduction 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = mq(6) / dsqrt(2.d0)       ! PDF: m(top) / sqrt(2)
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6)                     ! PDF: m(top) 
*       elseif(Ipar(3).eq.3) then
*         Rpar(3) =  Rpar(74)    ! PDF: sqrt(Shat)
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                       ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6) / dsqrt(2.d0)           ! alpha_s:
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6) 
*       elseif(Ipar(4).eq.3) then
*         Rpar(4) =  Rpar(74)                    ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3)
       endif
      GOTO 5555
***
 6    continue !   q q~' -> W+- + H+-  -> tau nu   
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(74)            ! PDF: sqrt(Shat) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) =  Rpar(74) 
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)           !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(74)         ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***
 7    continue !   q q~' -> H+- JET  -> tau nu   
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(5)            ! PDF: mass(H* or W*)
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) =  Rpar(5)
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)           ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(5)           ! alpha_s: mass(H* or W*)
       else
         Ipar(4) = 0                 ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***
 8    continue           !  H* -> t bbar 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then 
         Rpar(3) = mq(6) / dsqrt(2.d0)     ! PDF: m_t/sqrt(2) 
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6)                   ! PDF: m_t
       elseif(Ipar(3).eq.3) then
         Rpar(3) = Rpar(51)                ! PDF: M(H) 
       elseif(Ipar(3).eq.4) then
         Rpar(3) = Rpar(74)               ! PDF: sqrt(Shat) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6) / dsqrt(2.d0)
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)   
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                 !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6) / dsqrt(2.d0)     ! alpha_s: m(top) / dsqrt(2)
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6)                   ! alpha_s: m(top)
       elseif(Ipar(4).eq.3) then
         Rpar(4) = Rpar(51)                ! alpha_s: M(H)
       elseif(Ipar(4).eq.4) then
         Rpar(4) = Rpar(74)               ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***
 30    continue            !  FCNC g U -> t 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = mq(6)                   ! PDF: m_t
       elseif(Ipar(3).eq.2) then
         Rpar(3) = Rpar(74)               ! PDF: sqrt(Shat) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = mq(6)
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)   
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                 !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = mq(6)                   ! alpha_s: m(top)
         Rpar(4) = Rpar(74)                ! alpha_s: sqrt(Shat)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***
 31    continue            !  FCNC: 2 -> 2
*   Q-scale for PDF

       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> PDF
       elseif(Ipar(3).eq.2) then
         Rpar(3) = mq(6) / dsqrt(2.d0)       ! PDF: m(top) / sqrt(2)
       elseif(Ipar(3).eq.3) then
         Rpar(3) = mq(6)                     ! PDF: m_t
       else
         Ipar(3) = 1                         ! return to default version
         Rpar(3) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> PDF
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)                   !  equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = dsqrt(mq2(6) + Rpar(76)) ! Mt^2+pt(t)^2==> alpha_s
       elseif(Ipar(4).eq.2) then
         Rpar(4) = mq(6) / dsqrt(2.d0)       ! PDF: m(top) / sqrt(2)
       elseif(Ipar(4).eq.3) then
         Rpar(4) = mq(6)                    ! alpha_s: m(top)
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
*******
 61   continue !   H+ H- 
*   Q-scale for PDF
       if(    Ipar(3).eq.-1) then
         continue  ! Rpar(3) = ...(user's input)  
       elseif(Ipar(3).eq.1) then
         Rpar(3) =  Rpar(51)            ! PDF: mass(H+-) 
       else
         Ipar(3) = 1                       ! return to default version
         Rpar(3) = Rpar(51)
       endif
*   Q-scale for alpha_s 
       if(    Ipar(4).eq.-1) then
         continue  ! Rpar(4) = ...(user's input)  
       elseif(Ipar(4).eq.0) then
         Rpar(4) = Rpar(3)          ! equals to PDF Q-scale
       elseif(Ipar(4).eq.1) then
         Rpar(4) = Rpar(51 )        ! alpha_s: mass(H+-) 
       else
         Ipar(4) = 0                       ! return to default version
         Rpar(4) = Rpar(3) 
       endif
      GOTO 5555
***************************
 5555 continue   ! evaluate alpha_s
      Q22 = Rpar(4)**2
      rpar(15) = PYalps(Q22)   ! alpha_QCD = QCD coupling used for event   
      alpsZ    = PYalps(Rpar(46))  ! alpha_QCD = at MZ 
*      rpar(15) = 0.130d0 ! PYalps(Q22) !alpha_s = QCD coupling used for event   

      Rpar(16) = pi4 * Rpar(15)   
      Rpar(17) = dsqrt(Rpar(16)) 
      IF(first) THEN
       first = .false.
       write(*,1000) 
 1000  format(//,'   TopReX Q-scales',/,
     &           '   ----------------')
       ipr4 = ipar(4)
*       if(ipr4.eq.0) ipr4 = 1
       if(ipr4.eq.0) ipr4 = Ipar(3)
      If(ipar(3).ge.1) then 
        write(*,1001) namQpdf(Iprc, Ipar(3)),rpar(3) 
 1001  format('   PDF:     Q-scale is  ',a30,' = ',f10.3)
        if(ipar(4).ge.0)  write(*,1003) namQalf(Iprc, Ipr4),rpar(15),
     &              alpsz
        if(ipar(4).eq.-1) write(*,1004) Rpar(4),rpar(15), alpsz
      ElseIf(ipar(3).eq.-1) then
        write(*,1002) Rpar(3)
 1002  format('   PDF:     Q-scale, user input ',f10.3)
        if(ipar(4).ge.1)   write(*,1003) namQalf(Iprc, Ipr4),rpar(15),
     &            alpsz
        if(ipar(4).eq.0.OR.Ipar(4).eq.-1) write(*,1004) Rpar(4),
     &      rpar(15),   alpsz            
      EndIf
*
*      write(*,*) rpar(3),rpar(4)
*
 1003  format('   alpha_s: Q-scale is  ',a30,/,
     &        '   alpha_s = ',f7.4,'  alpha_s(MZ) = ',f7.4)
 1004  format('   alpha_s: Q-scale, user input ',f10.3,/,
     &        '   alpha_s = ',f7.4,'  alpha_s(MZ) = ',f7.4)
      ENDIF
      return
      end    
