
c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  22/10/2000                                  *
*                                                                            *
      subroutine TXWEAK 
*     ------------------                                                     *
*   electro-weak parameters, masses of gauge bosons and quarks, etc          *
*   part of parameter values are taken from PYTHIA                           *
*............................................................................*

      Implicit None
      include "pydat_62.inc"
      include "txpar.inc" 
      double precision mql,       mql2
      common /massql/  mql(0:20), mql2(0:20)
      double precision CKM2
      common /CKMD/ CKM2(-6:6,-6:6)

      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*--- Numerical data are from RPP-98
      double precision gfermi, a42, ad9
      data gfermi /1.16639d-5/
      Integer I, J, II, JJ
      save /massql/, /CKMD/, /piconst/
      double precision mqPDG(8)
* mass(q)    PDG: d        u        s        c       b       t     
      data mqPDG /0.009d0, 0.005d0, 0.150d0, 1.25d0, 4.62d0, 175.0d0, 
     &            -1.d0, -1.d0/   ! b-prime t-prime
*........
*
      pi=DACOS(-1.d0)
      pi2   = 2.d0*pi
      pi4   = 4.d0*pi
      pi2_3 = pi2**3
      pi2_4 = pi2**4
      pi2_6 = pi2**6

      Rpar(50) = 1000.d0  ! new scale      

*...recalculate conversion factor mb/GeV**2,  transformation 1/GeV**2 to mb
      rpar(10) = PARU(5) 
       a42 = Ipar(42)
       ad9 = 9.d0 - a42
         rpar(18) = 10**ad9 ! mbpb
         rpar(10) = rpar(10) * 10**a42
*
         print*,' transformation MB into PB:  10**',a42,
     &   ' addition ',rpar(18) 

      Rpar(14) = gFermi

       do J = 1,20
        mql(j) = 0.d0
       enddo
* leptons
       do J = 1,6
        mql((J+10)) = PMAS( (J+10),1)   ! leptons
       enddo 

       mql(0) = 0.d0    ! gluon

       do J = 1, 6
        if    (ipar(5).eq.0)  then
          mql(J) = PMAS(J,1)     ! PYTHIA values for quark masses
        elseif(ipar(5).eq.1)  then
          mql(J) = mqPDG(J)      ! PDG    values for quark masses
        endif 
       enddo
       mql(6) = PMAS(6,1)
       mql(5) = PMAS(5,1) !  4.62d0 ! comp

 777  format(2x,e12.5)
*
      do J = 0, 20
       mql2(J)   = mql(J)  * mql(J) 
      enddo

*      write(*, 244) (mql(J),J=1,6),(mql(J),J=11,16)
 244  format(/,'  mass (q) :   D      U      S      C      B      T',/,
     &12x,5(f6.3,1x),f7.2,/,
     &       '  leptons  :   E    NU_E    MU    NU_MU   TAU   NU_TAU',/,
     &12x,f6.4,1x,5(f6.3,1x))
*
* B mass       ! 4.6d0 - 4.8d0 polmass in ME!
* W-boson parameters
      Rpar(41) = PMAS(24,1) 
      Rpar(42) = PMAS(24,1)**2 
      Rpar(43) = PMAS(24,2) 
      Rpar(44) = Rpar(41) * Rpar(43) 
* Z-boson parameters
      Rpar(45) = PMAS(23,1)      !  mass
      Rpar(46) = PMAS(23,1)**2 
      Rpar(47) = PMAS(23,2) 
      Rpar(48) = Rpar(45) * Rpar(47) 
* H-boson (SM) parameters
      Rpar(57) = PMAS(25,1)      !  mass
      Rpar(58) = PMAS(25,2) 
      Rpar(59) = Rpar(57) * Rpar(58) 
* couplings,  here  theta_W = theta_Weinberg  
      Rpar(23) = PARU(102)                  ! sin(theta_W)**2 
      Rpar(21) = DSQRT(Rpar(23))            ! sin(theta_W)
      Rpar(24) = 1.d0 - Rpar(23)            ! cos^2(theta_W)
      Rpar(22) = DSQRT(Rpar(24))            ! cos(theta_W)
      Rpar(25) = 2.d0 * Rpar(21) * Rpar(22) ! sin(2*theta_W)
*...set alpha electromagnetic at vanishing momentum transfers
cls      rpar(11) = PARU(101)
      rpar(11) = PARU(103)  ! 1.d0 / 131.d0  ! 28.d0               ! alpha_QED
      Rpar(12) =       4.d0*pi*rpar(11)      ! electric charge**2
      Rpar(13) = dsqrt(4.d0*pi*rpar(11))     ! electric charge
      rpar(26) = Rpar(13) / Rpar(21)         ! g = g_weak = e / sin(theta_W)
      Rpar(27) = Rpar(13) / Rpar(25)         ! g_z        = e / sin(2*theta_W)
*
      Rpar(28) = 246.d0 / dsqrt(2.d0) 
*CKM matrix elements
      do i = -6,6
       do j = -6,6
        CKM2(i,j) = 0d0
       enddo
      enddo 
 
      do I = 1,3
       do J = 1,3
        II = 2 * I
        JJ = 2 * J -1
         CKM2( II, JJ) = VCKM(I, J)  ! squared CKM matrix elements 
         CKM2(-II, JJ) = VCKM(I, J)
         CKM2( II,-JJ) = VCKM(I, J)
         CKM2(-II,-JJ) = VCKM(I, J)
         CKM2( JJ, II) = VCKM(I, J)
         CKM2(-JJ, II) = VCKM(I, J)
         CKM2( JJ,-II) = VCKM(I, J)
         CKM2(-JJ,-II) = VCKM(I, J)
       enddo
      enddo
      call Vbosoncpl  ! evaluate gamma/Z-boson couplings
      return
      end
