*----------------------------------------------------------------------------*
*   
      subroutine Vbosoncpl 
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc"
*..Rpar(23)     : sin(theta_W)**2                                            *
*..Rpar(24)     : cos(theta_W)**2                                            *
*..Rpar(25)     : sin(2*theta_W) = 2 * sin(theta_W) * cos(theta_W)           *
*..Rpar(26)     : g = g_weak  = e / sin(theta_W)                             *
*..Rpar(27)     : g_z         = e / sin(2*theta_W)                           *
* eqf(1, n) : electric charge in |Q(electron)| units
* eqf(2, n) : e(QED) * eqf(1, n)
* zff  times  3 / sin(2 theta_W)
* zff(1, n) : gv <=> gamma^mu
* zff(2, n) : ga <=> gamma^mu * gamma^5
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff
      save /Vboscpl/
      integer J
*
      do j = 1,20
       eqf(1,j) = 0.d0
       eqf(2,j) = 0.d0
       zff(1,j) = 0.d0
       zff(2,j) = 0.d0
      enddo

       eqf(1,1) = -1.d0 / 3.d0  ! d
       eqf(1,2) = +2.d0 / 3.d0  ! u
       eqf(1,3) = eqf(1,1)     
       eqf(1,4) = eqf(1,2)
       eqf(1,5) = eqf(1,1) 
       eqf(1,6) = eqf(1,2) 
       eqf(1,7) = eqf(1,1) 
       eqf(1,8) = eqf(1,2) 
       eqf(1,11) = -1. ! e-
       eqf(1,13) = -1. ! mu-
       eqf(1,15) = -1. ! tau
       eqf(1,17) = -1. ! L-

      do j = 1,20
       eqf(2,j)  = Rpar(13) * eqf(1,j) 
       eqf(1,-j) = -eqf(1,j) 
       eqf(2,-j) = -eqf(2,j) 
      enddo


      zff(1,1) = rpar(27) * (-0.5d0 + (2.d0/3.d0)*rpar(23))  ! D-quark V
      zff(2,1) = rpar(27) * (+0.5d0 )                        ! D-quark A
      zff(1,3) =   zff(1,1) ! S-quark
      zff(2,3) =   zff(2,1) !
      zff(1,5) =   zff(1,1) ! B-quark
      zff(2,5) =   zff(2,1) 
      zff(1,2) = rpar(27) * (+0.5d0 - (4.d0/3.d0)*rpar(23))  ! UP-quark
      zff(2,2) = rpar(27) * (-0.5d0 )                        ! UP-quark
      zff(1,4) =   zff(1,2) ! C-quark
      zff(2,4) =   zff(2,2) 
      zff(1,6) =   zff(1,2) ! T-quark
      zff(2,6) =   zff(2,2) 
*  leptons
      zff(1,11) = rpar(27) * (-0.5d0 + 2.d0*rpar(23))        ! e- 
      zff(2,11) = rpar(27) * (+0.5d0 ) 
      zff(1,13) =   zff(1,11)  ! mu-
      zff(2,13) =   zff(2,11)
      zff(1,15) =   zff(1,11)  ! tau-
      zff(2,15) =   zff(2,11)
*
      zff(1,12) = rpar(27) * (+0.5d0)           ! nu- 
      zff(2,12) = rpar(27) * (-0.5d0 ) 
      zff(1,14) =   zff(1,12)  ! nu_mu
      zff(2,14) =   zff(2,12)
      zff(1,16) =   zff(1,12)  ! nu_tau
      zff(2,16) =   zff(2,12)
      do j = 1,20
       zff(1,-j) = zff(1,j) 
       zff(2,-j) = zff(2,j) 
      enddo
      RETURN
      END
