*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.10.2001                                  *
      Subroutine Vortas(P, V) 
*     ----------------------                                                 *
*  three orthogonal vectors                                                  *
*  in P rest frame : V(1,...) = e_x,  V(2,...) = e_y,  V(3,...) = e_z        *
*... input                                                                   *
*  P(5) is 5-momentum                                                        *
*... Output : V(3,4)                                                         *
*............................................................................*

      implicit None
      double precision P(5), Z, v(3,4) 
*
*  e_x (1)
      Z = p(1) / (p(5) * (p(5) + p(4)) )
       V(1,4) = p(1) / p(5) 
       V(1,1) = p(1) * z + 1.d0
       V(1,2) = p(2) * z
       V(1,3) = p(3) * z
*  e_y (2)
      Z = p(2) / (p(5) * (p(5) + p(4)) )
       V(2,4) = p(2) / p(5) 
       V(2,1) = p(1) * z 
       V(2,2) = p(2) * z + 1.d0
       V(2,3) = p(3) * z
*  e_z (3)
      Z = p(3) / (p(5) * (p(5) + p(4)) )
       V(3,4) = p(3) / p(5) 
       V(3,1) = p(1) * z 
       V(3,2) = p(2) * z
       V(3,3) = p(3) * z + 1.d0
      return
      end
