c----------------------------------------------------------------------------c
*.. author:   Serge Slabospitsky   20.03.2001                                *
      subroutine W_dec_ini
*     --------------------                                                   *
*     decay table for W's                                                    *
* it is assumed, that FIRST W-boson is POSITIVE, i.e.  W(1) = W+  W(2) = W-  *
* Five possibilites of W-boson decay channel are considered MDW(==MDME) :    *
*   = -1 not considered at all,                                              *
*   =  0 contribute to width, but not to decay                               *
*   =  1 contribute to both W+ and W- decay                                  *
*   =  2 contribute to W+, but not to W- decay                               *
*   =  3 contribute to W-, but not to W+ decay                               *
*  order of fermions in W-boson decay channel is opposite to PYTHIA          *
*....  TopReX prescription
*   1 = u d~     2 = c d~     3 = t d~      4 = t4 d~
*   5 = u s~     6 = c s~     7 = t s~      8 = t4 s~
*   9 = u b~    10 = c b~    11 = t b~     12 = t4 b~
*  13 = u b4~   14 = c b4~   15 = t b4~    16 = t4 b4~
*  17 = nu e+   18 = nu mu+  19 = nu tau+  20 = nu L+
*............................................................................*
      Implicit None
      INTEGER   J
      integer IT        
*  IT= 1 : top quark,  IT= 2 : W-boson, IT= 3 : H+- boson,  IT= 4 : Z-boson 
* mid(0, IT) is NIDCmax, i.e. max. number of decay channels
*
      include "txpar.inc" 
*...........
      character*4 chl(-1:3)
      data chl /'no  ','OFF ','W+W-','W+  ','W-  '/
*.....
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*
      if(.NOT.first) return 
      first=.FALSE.
       IT = 2
       do J = 1, mid(0, IT) 
       if(mid(j, IT).ge.4) then
          write(*,202) j,it,mid(j, IT) 
 202      format('  TopReX : W_dec_ini: MID(',i2,',',i1,') = ',i2,
     &3x,'could not be used')
          STOP
        endif   
       enddo

       BRS(1, IT) = 0.0d0   ! W+
       BRS(2, IT) = 0.0d0   ! W-
      do J = 1, mid(0, IT)
        if(Mid(j,IT).eq.1.OR.Mid(j,IT).eq.2) 
     &     BRS(1,IT) = BRS(1,IT) + brf(j, IT)        ! W+
        if(Mid(j,IT).eq.1.OR.Mid(j,IT).eq.3) 
     &     BRS(2,IT) = BRS(2,IT) + brf(j, IT)        ! W-
      enddo 
      write(*, 71)
 71   format(/,'   TopReX : W decay channels contributed to width',/
     &,        '   ----------------------------------------------')
       write(*, 172) (chl(mid(j, IT)),j = 1,3),
     &                  (chl(mid(j, IT)),j = 5,7),
     &                  (chl(mid(j, IT)),j = 9,11),
     &                  (chl(mid(j, IT)),j = 17,19)
 172  format(2x,'U Dbar: ',a4,'  C Dbar: ',a4,'  T Dbar: ',a4,/,
     &       2x,'U Sbar: ',a4,'  C Sbar: ',a4,'  T Sbar: ',a4,/,
     &       2x,'U Bbar: ',a4,'  C Bbar: ',a4,'  T Bbar: ',a4,/,
     &       2x,'NU   E: ',a4,'  NU  MU: ',a4,'  NU tau: ',a4)

      WRITE(*,201) (BRS(j,IT),j=1,2)
 201  format(/,'  TopReX : branching for W-boson',/
     &,'  W+      ',1p,d10.3,/
     &,'  W-      ',d10.3)
      return
      end 
