*----------------------------------------------------------------------------*
*.. author:   Serge Slabospitsky   29.06.2001                                *
      subroutine Z_dec_ini       
*     --------------------                                                   *
*     decay table for Z-boson                                                *
* Only THREE possibilities of Z-boson decay channel are considered           *
* MID((i,  3) = MDME): -1 -- closed,                                         *
*  0 -- contributes to width, but not to decay                               *
*  1 -- contribute to Z-boson decay                                          *
* order of fermions in Z-boson decay channel is identical to PYTHIA          *
*............................................................................*
      Implicit None
* IT= 1 : top quark,  IT= 2 : W-boson, IT= 3 : H+- boson,  IT= 4 : Z-boson 
* mid(0, IT) is the total number of decay channels
*
      include "txpar.inc"  
      integer IT, J        
      Character*14 INAM2(16)
      data INAM2 /
     &' D      Dbar  ', ' U      Ubar  ', ' S      Sbar  ', 
     &' C      Cbar  ', ' B      Bbar  ', ' T      Tbar  ', 
     &' B4     B4bar ', ' t4     t4bar ', ' e-  e+       ', 
     &' nu_e   nu~   ', ' mu-    mu+   ', ' nu_mu  nu~   ', 
     &' tau-   tau+  ', ' nu_tau nu~   ', ' L-     L+    ', 
     &'              ' /
* mid(N,4) Z-boson
* N = 1 : D Dbar,   N = 2 : U Ubar,    N = 3 : S Sbar,   N = 4 : C Cbar
* N = 5 : B Bbar,   N = 6 : T Tbar,    N = 7 : B4 B4bar, N = 8 : t4 t4bar
* N = 9 : e- e+,    N = 10: nu_e nu~,  N = 11: mu- mu+,  N = 12: nu_mu nu~
* N = 13: tau- tau+ N = 14: nu_tau nu~ N = 15: L- L+     N = 16: NU4 NU4~

      character*5 chl(-1:3)
      data chl /'no   ','OFF  ','Z    ','Z    ','Z    '/
*.....
       IT = 4
       do J = 1, mid(0, IT) 
       if(mid(j, IT).ge.2) then
          write(*,202) mid(j, IT), inam2(j) 
 202      format('  TopReX : Z_dec_ini  ',/,
     &3x,'mode ',i2,' is not implemented yet for Z -> ',/,
     &3x,' stop TopReX running ')
          STOP
        endif   
       enddo
      
      BRS(1,IT) = 0.0d0
      do j = 1, mid(0, IT)
        if (Mid(j, IT).ne.0.AND.Mid(j, IT).ne.-1) THEN
           if(Mid(j, IT).eq.1) BRS(1,IT) = BRS(1,IT) + brf(j, IT)
        endif 
      enddo 

      BRS(2, IT) = BRS(1, IT) 
      write(*, 71)
 71   format(/,'   TopReX : Z decay channels contributed to width',/
     &,        '   ----------------------------------------------')
       write(*, 172) (chl(mid(j, IT)),j = 1,3),
     &                  (chl(mid(j, IT)),j = 4,6),
     &                  (chl(mid(j, IT)),j = 9,10),
     &                  (chl(mid(j, IT)),j = 11,12),
     &                  (chl(mid(j, IT)),j = 13,14)
 172  format(2x,'D    Dbar: ',a5,'U    Ubar: ',a5,' S Sbar: ',a5,/,
     &       2x,'C    Cbar: ',a5,'B    Bbar: ',a5,' T Tbar: ',a5,/,
     &       2x,'e-    e+ : ',a5,'NUe   NU~: ',a5,/,
     &       2x,'mu-   mu+: ',a5,'NUmu  NU~: ',a5,/,
     &       2x,'tau- tau+: ',a5,'NUtau NU~: ',a5)

      WRITE(*,201) BRS(1, IT) 
 201  format(/,'  TopReX : total branching for Z-boson = ',1p,d10.3)
      return
      end 
